!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 22

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(255)
  integer, parameter :: nGC_MI = 1
  integer, parameter :: nGC_MS = 2
  integer, parameter :: nGC_13 = 3
  integer, parameter :: nGC_1348 = 4
  integer, parameter :: nGC_1349 = 5
  integer, parameter :: nGC_12 = 6
  integer, parameter :: nGC_11 = 7
  integer, parameter :: nGC_10 = 8
  integer, parameter :: nGC_22 = 9
  integer, parameter :: nGC_2484 = 10
  integer, parameter :: nGC_2487 = 11
  integer, parameter :: nGC_1485 = 12
  integer, parameter :: nGC_1484 = 13
  integer, parameter :: nGC_1486 = 14
  integer, parameter :: nGC_2717 = 15
  integer, parameter :: nGC_178 = 16
  integer, parameter :: nGC_2158 = 17
  integer, parameter :: nGC_170 = 18
  integer, parameter :: nGC_172 = 19
  integer, parameter :: nGC_2156 = 20
  integer, parameter :: nGC_2138 = 21
  integer, parameter :: nGC_2135 = 22
  integer, parameter :: nGC_2720 = 23
  integer, parameter :: nGC_MU = 24
  integer, parameter :: nGC_2 = 25
  integer, parameter :: nGC_2109 = 26
  integer, parameter :: nGC_2108 = 27
  integer, parameter :: nGC_1496 = 28
  integer, parameter :: nGC_1497 = 29
  integer, parameter :: nGC_1498 = 30
  integer, parameter :: nGC_1499 = 31
  integer, parameter :: nGC_MC = 32
  integer, parameter :: nGC_MB = 33
  integer, parameter :: nGC_2194 = 34
  integer, parameter :: nGC_26 = 35
  integer, parameter :: nGC_2023 = 36
  integer, parameter :: nGC_2021 = 37
  integer, parameter :: nGC_2026 = 38
  integer, parameter :: nGC_2024 = 39
  integer, parameter :: nGC_2025 = 40
  integer, parameter :: nGC_1441 = 41
  integer, parameter :: nGC_2020 = 42
  integer, parameter :: nGC_1372 = 43
  integer, parameter :: nGC_1375 = 44
  integer, parameter :: nGC_2143 = 45
  integer, parameter :: nGC_14 = 46
  integer, parameter :: nGC_2262 = 47
  integer, parameter :: nGC_1368 = 48
  integer, parameter :: nGC_1369 = 49
  integer, parameter :: nGC_1360 = 50
  integer, parameter :: nGC_1361 = 51
  integer, parameter :: nGC_1362 = 52
  integer, parameter :: nGC_1363 = 53
  integer, parameter :: nGC_1364 = 54
  integer, parameter :: nGC_1365 = 55
  integer, parameter :: nGC_1366 = 56
  integer, parameter :: nGC_1367 = 57
  integer, parameter :: nGC_2677 = 58
  integer, parameter :: nGC_616 = 59
  integer, parameter :: nGC_MD = 60
  integer, parameter :: nGC_2678 = 61
  integer, parameter :: nGC_1355 = 62
  integer, parameter :: nGC_1354 = 63
  integer, parameter :: nGC_1357 = 64
  integer, parameter :: nGC_1356 = 65
  integer, parameter :: nGC_1351 = 66
  integer, parameter :: nGC_1350 = 67
  integer, parameter :: nGC_1353 = 68
  integer, parameter :: nGC_1352 = 69
  integer, parameter :: nGC_1500 = 70
  integer, parameter :: nGC_1359 = 71
  integer, parameter :: nGC_1358 = 72
  integer, parameter :: nGC_3 = 73
  integer, parameter :: nGC_1 = 74
  integer, parameter :: nGC_7 = 75
  integer, parameter :: nGC_6 = 76
  integer, parameter :: nGC_5 = 77
  integer, parameter :: nGC_4 = 78
  integer, parameter :: nGC_9 = 79
  integer, parameter :: nGC_8 = 80
  integer, parameter :: nGC_118 = 81
  integer, parameter :: nGC_112 = 82
  integer, parameter :: nGC_110 = 83
  integer, parameter :: nGC_52 = 84
  integer, parameter :: nGC_2244 = 85
  integer, parameter :: nGC_2065 = 86
  integer, parameter :: nGC_2140 = 87
  integer, parameter :: nGC_2068 = 88
  integer, parameter :: nGC_1489 = 89
  integer, parameter :: nGC_1488 = 90
  integer, parameter :: nGC_2485 = 91
  integer, parameter :: nGC_1483 = 92
  integer, parameter :: nGC_1487 = 93
  integer, parameter :: nGC_2088 = 94
  integer, parameter :: nGC_1400 = 95
  integer, parameter :: nGC_1403 = 96
  integer, parameter :: nGC_1402 = 97
  integer, parameter :: nGC_2718 = 98
  integer, parameter :: nGC_1404 = 99
  integer, parameter :: nGC_1407 = 100
  integer, parameter :: nGC_1409 = 101
  integer, parameter :: nGC_2082 = 102
  integer, parameter :: nGC_2245 = 103
  integer, parameter :: nGC_368 = 104
  integer, parameter :: nGC_2157 = 105
  integer, parameter :: nGC_2136 = 106
  integer, parameter :: nGC_2721 = 107
  integer, parameter :: nGC_1412 = 108
  integer, parameter :: nGC_1410 = 109
  integer, parameter :: nGC_2105 = 110
  integer, parameter :: nGC_1399 = 111
  integer, parameter :: nGC_1398 = 112
  integer, parameter :: nGC_1393 = 113
  integer, parameter :: nGC_1392 = 114
  integer, parameter :: nGC_1395 = 115
  integer, parameter :: nGC_1394 = 116
  integer, parameter :: nGC_1397 = 117
  integer, parameter :: nGC_1396 = 118
  integer, parameter :: nGC_1494 = 119
  integer, parameter :: nGC_1490 = 120
  integer, parameter :: nGC_1491 = 121
  integer, parameter :: nGC_1387 = 122
  integer, parameter :: nGC_1384 = 123
  integer, parameter :: nGC_1385 = 124
  integer, parameter :: nGC_1382 = 125
  integer, parameter :: nGC_1383 = 126
  integer, parameter :: nGC_1380 = 127
  integer, parameter :: nGC_1381 = 128
  integer, parameter :: nGC_2054 = 129
  integer, parameter :: nGC_1388 = 130
  integer, parameter :: nGC_1389 = 131
  integer, parameter :: nGC_1390 = 132
  integer, parameter :: nGC_2195 = 133
  integer, parameter :: nGC_2029 = 134
  integer, parameter :: nGC_252 = 135
  integer, parameter :: nGC_1444 = 136
  integer, parameter :: nGC_2204 = 137
  integer, parameter :: nGC_1442 = 138
  integer, parameter :: nGC_1378 = 139
  integer, parameter :: nGC_246 = 140
  integer, parameter :: nGC_1379 = 141
  integer, parameter :: nGC_244 = 142
  integer, parameter :: nGC_1373 = 143
  integer, parameter :: nGC_1371 = 144
  integer, parameter :: nGC_1370 = 145
  integer, parameter :: nGC_1377 = 146
  integer, parameter :: nGC_1376 = 147
  integer, parameter :: nGC_1374 = 148
  integer, parameter :: nGC_2112 = 149
  integer, parameter :: nGC_164 = 150
  integer, parameter :: nGC_1391 = 151
  integer, parameter :: nGC_1452 = 152
  integer, parameter :: nGC_1453 = 153
  integer, parameter :: nGC_1450 = 154
  integer, parameter :: nGC_1451 = 155
  integer, parameter :: nGC_1456 = 156
  integer, parameter :: nGC_1457 = 157
  integer, parameter :: nGC_1454 = 158
  integer, parameter :: nGC_1455 = 159
  integer, parameter :: nGC_2070 = 160
  integer, parameter :: nGC_1458 = 161
  integer, parameter :: nGC_1459 = 162
  integer, parameter :: nGC_2077 = 163
  integer, parameter :: nGC_1416 = 164
  integer, parameter :: nGC_3167 = 165
  integer, parameter :: nGC_3168 = 166
  integer, parameter :: nGC_3169 = 167
  integer, parameter :: nGC_1443 = 168
  integer, parameter :: nGC_2205 = 169
  integer, parameter :: nGC_1480 = 170
  integer, parameter :: nGC_1461 = 171
  integer, parameter :: nGC_1492 = 172
  integer, parameter :: nGC_1493 = 173
  integer, parameter :: nGC_1419 = 174
  integer, parameter :: nGC_1427 = 175
  integer, parameter :: nGC_1426 = 176
  integer, parameter :: nGC_1425 = 177
  integer, parameter :: nGC_1424 = 178
  integer, parameter :: nGC_1423 = 179
  integer, parameter :: nGC_1422 = 180
  integer, parameter :: nGC_1421 = 181
  integer, parameter :: nGC_2263 = 182
  integer, parameter :: nGC_2300 = 183
  integer, parameter :: nGC_2305 = 184
  integer, parameter :: nGC_2304 = 185
  integer, parameter :: nGC_1401 = 186
  integer, parameter :: nGC_1429 = 187
  integer, parameter :: nGC_1405 = 188
  integer, parameter :: nGC_1386 = 189
  integer, parameter :: nGC_3434 = 190
  integer, parameter :: nGC_3432 = 191
  integer, parameter :: nGC_2139 = 192
  integer, parameter :: nGC_1417 = 193
  integer, parameter :: nGC_1420 = 194
  integer, parameter :: nGC_1470 = 195
  integer, parameter :: nGC_1434 = 196
  integer, parameter :: nGC_1435 = 197
  integer, parameter :: nGC_1436 = 198
  integer, parameter :: nGC_1437 = 199
  integer, parameter :: nGC_1430 = 200
  integer, parameter :: nGC_1431 = 201
  integer, parameter :: nGC_1432 = 202
  integer, parameter :: nGC_1433 = 203
  integer, parameter :: nGC_2196 = 204
  integer, parameter :: nGC_1471 = 205
  integer, parameter :: nGC_1414 = 206
  integer, parameter :: nGC_1415 = 207
  integer, parameter :: nGC_1438 = 208
  integer, parameter :: nGC_1413 = 209
  integer, parameter :: nGC_1476 = 210
  integer, parameter :: nGC_1411 = 211
  integer, parameter :: nGC_1473 = 212
  integer, parameter :: nGC_1475 = 213
  integer, parameter :: nGC_1474 = 214
  integer, parameter :: nGC_1446 = 215
  integer, parameter :: nGC_1418 = 216
  integer, parameter :: nGC_1439 = 217
  integer, parameter :: nGC_1462 = 218
  integer, parameter :: nGC_2145 = 219
  integer, parameter :: nGC_2144 = 220
  integer, parameter :: nGC_3174 = 221
  integer, parameter :: nGC_1477 = 222
  integer, parameter :: nGC_2069 = 223
  integer, parameter :: nGC_1445 = 224
  integer, parameter :: nGC_1447 = 225
  integer, parameter :: nGC_2038 = 226
  integer, parameter :: nGC_2488 = 227
  integer, parameter :: nGC_1440 = 228
  integer, parameter :: nGC_1472 = 229
  integer, parameter :: nGC_1449 = 230
  integer, parameter :: nGC_1448 = 231
  integer, parameter :: nGC_1464 = 232
  integer, parameter :: nGC_2043 = 233
  integer, parameter :: nGC_1469 = 234
  integer, parameter :: nGC_1468 = 235
  integer, parameter :: nGC_2042 = 236
  integer, parameter :: nGC_1460 = 237
  integer, parameter :: nGC_1406 = 238
  integer, parameter :: nGC_1463 = 239
  integer, parameter :: nGC_1408 = 240
  integer, parameter :: nGC_2301 = 241
  integer, parameter :: nGC_2083 = 242
  integer, parameter :: nGC_1467 = 243
  integer, parameter :: nGC_1466 = 244
  integer, parameter :: nGC_1465 = 245
  integer, parameter :: nGC_1428 = 246
  integer, parameter :: nGC_1478 = 247
  integer, parameter :: nGC_2197 = 248
  integer, parameter :: nGC_1479 = 249
  integer, parameter :: nGC_2239 = 250
  integer, parameter :: nGC_2159 = 251
  integer, parameter :: nGC_2039 = 252
  integer, parameter :: nGC_2113 = 253
  integer, parameter :: nGC_2031 = 254
  integer, parameter :: nGC_2030 = 255
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
