!******************************************************************************!
!                                                                              !
!    class_loop.f90                                                            !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_loop.f90                                 |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_loop
  use constants_mdl
  use input_mdl, only: error_mdl
  use lcVVVSSVS, only: loopVVVSSVS
  use lcVSVSVVS, only: loopVSVSVVS
  use lcVVSSS, only: loopVVSSS
  use lcSVSSVV, only: loopSVSSVV
  use lcSSVVS, only: loopSSVVS
  use lcSSSVVV, only: loopSSSVVV
  use lcVSVSVS, only: loopVSVSVS
  use lcSVVVSSV, only: loopSVVVSSV
  use lcVVVSVSS, only: loopVVVSVSS
  use lcSVSVSV, only: loopSVSVSV
  use lcSVSVVSV, only: loopSVSVVSV
  use lcSVVVVS, only: loopSVVVVS
  use lcVSVVSS, only: loopVSVVSS
  use lcVVVSS, only: loopVVVSS
  use lcVVVVS, only: loopVVVVS
  use lcSSVVSV, only: loopSSVVSV
  use lcVUaU, only: loopVUaU
  use lcSSSVVVV, only: loopSSSVVVV
  use lcVFFa, only: loopVFFa
  use lcVVS, only: loopVVS
  use lcVVSSV, only: loopVVSSV
  use lcVSVSS, only: loopVSVSS
  use lcVSSVSVV, only: loopVSSVSVV
  use lcVVSSVS, only: loopVVSSVS
  use lcVSVVSVS, only: loopVSVVSVS
  use lcVVVSSSV, only: loopVVVSSSV
  use lcSSVVSVV, only: loopSSVVSVV
  use lcVSVSSVV, only: loopVSVSSVV
  use lcSVVVVSS, only: loopSVVVVSS
  use lcUaUV, only: loopUaUV
  use lcVSSVVSV, only: loopVSSVVSV
  use lcVVVSSS, only: loopVVVSSS
  use lcVSSSVV, only: loopVSSSVV
  use lcVVSV, only: loopVVSV
  use lcSVSVS, only: loopSVSVS
  use lcSVVVS, only: loopSVVVS
  use lcVVSSVVS, only: loopVVSSVVS
  use lcVVSVSVS, only: loopVVSVSVS
  use lcFaVF, only: loopFaVF
  use lcSVVVSS, only: loopSVVVSS
  use lcSVVSVS, only: loopSVVSVS
  use lcSSVSVVV, only: loopSSVSVVV
  use lcVSSVS, only: loopVSSVS
  use lcSSVVVSV, only: loopSSVVVSV
  use lcSVVVSV, only: loopSVVVSV
  use lcSSSS, only: loopSSSS
  use lcSSS, only: loopSSS
  use lcSSVVVS, only: loopSSVVVS
  use lcSSVSVV, only: loopSSVSVV
  use lcVSSVVS, only: loopVSSVVS
  use lcSVSSVVV, only: loopSVSSVVV
  use lcSSVVVVS, only: loopSSVVVVS
  use lcVSSSV, only: loopVSSSV
  use lcVSVSSV, only: loopVSVSSV
  use lcUVUa, only: loopUVUa
  use lcVUUa, only: loopVUUa
  use lcSSSVV, only: loopSSSVV
  use lcVVVS, only: loopVVVS
  use lcSVSV, only: loopSVSV
  use lcVVVVSSS, only: loopVVVVSSS
  use lcSVVS, only: loopSVVS
  use lcSVVSVVS, only: loopSVVSVVS
  use lcVSSVSV, only: loopVSSVSV
  use lcVVSVSS, only: loopVVSVSS
  use lcSVVSSVV, only: loopSVVSSVV
  use lcVVSSSVV, only: loopVVSSSVV
  use lcVVSS, only: loopVVSS
  use lcSVSVSVV, only: loopSVSVSVV
  use lcSVVVV, only: loopSVVVV
  use lcFFaV, only: loopFFaV
  use lcSSVSV, only: loopSSVSV
  use lcVVV, only: loopVVV
  use lcVSSSVVV, only: loopVSSSVVV
  use lcVVSSSV, only: loopVVSSSV
  use lcVSVVVSS, only: loopVSVVVSS
  use lcFaFV, only: loopFaFV
  use lcVVSVSSV, only: loopVVSVSSV
  use lcVVVSSV, only: loopVVVSSV
  use lcUaVU, only: loopUaVU
  use lcVSV, only: loopVSV
  use lcSVSVVVS, only: loopSVSVVVS
  use lcVVVV, only: loopVVVV
  use lcFVFa, only: loopFVFa
  use lcVVSVVSS, only: loopVVSVVSS
  use lcVSSVVVS, only: loopVSSVVVS
  use lcVSVSVSV, only: loopVSVSVSV
  use lcSVV, only: loopSVV
  use lcVVVVSS, only: loopVVVVSS
  use lcSVSVVS, only: loopSVSVVS
  use lcSVVSVSV, only: loopSVVSVSV
  use lcUUaV, only: loopUUaV
  use lcSVVSSV, only: loopSVVSSV
  use lcVVVSV, only: loopVVVSV
  use lcSVVSS, only: loopSVVSS
  use lcSVSSV, only: loopSVSSV
  use lcVFaF, only: loopVFaF
  use lcSVVVSVS, only: loopSVVVSVS
  use lcVSSV, only: loopVSSV
  use lcVSVVSSV, only: loopVSVVSSV
  use lcVVSSVSV, only: loopVVSSVSV
  use lcSVVSV, only: loopSVVSV
  use lcSVVV, only: loopSVVV
  implicit none

  interface compute_loop_mdl
    module procedure computeLoop2, computeLoop3, computeLoop4, computeLoop5,   &
    computeLoop6, computeLoop7, computeLoop8
  end interface 

  contains

  subroutine computeLoop2(ty, co, wl, P1, PL1, m, wp, riMaxIn, riMaxOut,       &
  rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop2

  subroutine computeLoop3(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,    &
  riMaxOut, rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case(VUaU0)
      call loopVUaU(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VFFa0)
      call loopVFFa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VVS0)
      call loopVVS(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut, &
      rankInc)
    case(UaUV0)
      call loopUaUV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(FaVF0)
      call loopFaVF(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(SSS0)
      call loopSSS(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut, &
      rankInc)
    case(UVUa0)
      call loopUVUa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VUUa0)
      call loopVUUa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(FFaV0)
      call loopFFaV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VVV0)
      call loopVVV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut, &
      rankInc)
    case(FaFV0)
      call loopFaFV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(UaVU0)
      call loopUaVU(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VSV0)
      call loopVSV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut, &
      rankInc)
    case(FVFa0)
      call loopFVFa(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(SVV0)
      call loopSVV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut, &
      rankInc)
    case(UUaV0)
      call loopUUaV(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case(VFaF0)
      call loopVFaF(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn, riMaxOut &
      , rankInc)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop3

  subroutine computeLoop4(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp &
  , riMaxIn, riMaxOut, rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
    complex (kind = dp), intent(in), dimension(0:3) :: w3
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case(VVSV0)
      call loopVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(SSSS0)
      call loopSSSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(VVVS0)
      call loopVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(SVSV0)
      call loopSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(SVVS0)
      call loopSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(VVSS0)
      call loopVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(VVVV0)
      call loopVVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(VSSV0)
      call loopVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case(SVVV0)
      call loopSVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,      &
      riMaxIn, riMaxOut, rankInc)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop4

  subroutine computeLoop5(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
    complex (kind = dp), intent(in), dimension(0:3) :: w3
    complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
    complex (kind = dp), intent(in), dimension(0:3) :: w4
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case(VVSSS0)
      call loopVVSSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVS0)
      call loopSSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSS0)
      call loopVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVVS0)
      call loopVVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSV0)
      call loopVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSS0)
      call loopVSVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVS0)
      call loopSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVS0)
      call loopSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVS0)
      call loopVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSSV0)
      call loopVSSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSSVV0)
      call loopSSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVV0)
      call loopSVVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVSV0)
      call loopSSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSV0)
      call loopVVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSS0)
      call loopSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSSV0)
      call loopSVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSV0)
      call loopSVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4, PL4&
      , m, wp, riMaxIn, riMaxOut, rankInc)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop5

  subroutine computeLoop6(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
    complex (kind = dp), intent(in), dimension(0:3) :: w3
    complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
    complex (kind = dp), intent(in), dimension(0:3) :: w4
    complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
    complex (kind = dp), intent(in), dimension(0:3) :: w5
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case(SVSSVV0)
      call loopSVSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSSVVV0)
      call loopSSSVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSVS0)
      call loopVSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVSV0)
      call loopSVSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVVS0)
      call loopSVVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVVSS0)
      call loopVSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVSV0)
      call loopSSVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSVS0)
      call loopVVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSSS0)
      call loopVVVSSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSSVV0)
      call loopVSSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVSS0)
      call loopSVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSVS0)
      call loopSVVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVSV0)
      call loopSVVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVVS0)
      call loopSSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVSVV0)
      call loopSSVSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVVS0)
      call loopVSSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSSV0)
      call loopVSVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVSV0)
      call loopVSSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSVSS0)
      call loopVVSVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSSV0)
      call loopVVSSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSSV0)
      call loopVVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVVSS0)
      call loopVVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVVS0)
      call loopSVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSSV0)
      call loopSVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,   &
      PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop6

  subroutine computeLoop7(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
    complex (kind = dp), intent(in), dimension(0:3) :: w3
    complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
    complex (kind = dp), intent(in), dimension(0:3) :: w4
    complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
    complex (kind = dp), intent(in), dimension(0:3) :: w5
    complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
    complex (kind = dp), intent(in), dimension(0:3) :: w6
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case(VVVSSVS0, VVVSSVS1, VVVSSVS2)
      call loopVVVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSVVS0, VSVSVVS1, VSVSVVS2)
      call loopVSVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVSSV0, SVVVSSV1, SVVVSSV2)
      call loopSVVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSVSS0, VVVSVSS1, VVVSVSS2)
      call loopVVVSVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVVSV0, SVSVVSV1, SVSVVSV2)
      call loopSVSVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSSVVVV0, SSSVVVV1, SSSVVVV2)
      call loopSSSVVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVSVV0, VSSVSVV1, VSSVSVV2)
      call loopVSSVSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVVSVS0, VSVVSVS1, VSVVSVS2)
      call loopVSVVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVSSSV0, VVVSSSV1, VVVSSSV2)
      call loopVVVSSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVSVV0, SSVVSVV1, SSVVSVV2)
      call loopSSVVSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSSVV0, VSVSSVV1, VSVSSVV2)
      call loopVSVSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVVSS0, SVVVVSS1, SVVVVSS2)
      call loopSVVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVVSV0, VSSVVSV1, VSSVVSV2)
      call loopVSSVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSVVS0, VVSSVVS1, VVSSVVS2)
      call loopVVSSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSVSVS0, VVSVSVS1, VVSVSVS2)
      call loopVVSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVSVVV0, SSVSVVV1, SSVSVVV2)
      call loopSSVSVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVVSV0, SSVVVSV1, SSVVVSV2)
      call loopSSVVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSSVVV0, SVSSVVV1, SVSSVVV2)
      call loopSVSSVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SSVVVVS0, SSVVVVS1, SSVVVVS2)
      call loopSSVVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVVVSSS0, VVVVSSS1, VVVVSSS2)
      call loopVVVVSSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSVVS0, SVVSVVS1, SVVSVVS2)
      call loopSVVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSSVV0, SVVSSVV1, SVVSSVV2)
      call loopSVVSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSSVV0, VVSSSVV1, VVSSSVV2)
      call loopVVSSSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVSVV0, SVSVSVV1, SVSVSVV2)
      call loopSVSVSVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSSVVV0, VSSSVVV1, VSSSVVV2)
      call loopVSSSVVV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVVVSS0, VSVVVSS1, VSVVVSS2)
      call loopVSVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSVSSV0, VVSVSSV1, VVSVSSV2)
      call loopVVSVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVSVVVS0, SVSVVVS1, SVSVVVS2)
      call loopSVSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSVVSS0, VVSVVSS1, VVSVVSS2)
      call loopVVSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSSVVVS0, VSSVVVS1, VSSVVVS2)
      call loopVSSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVSVSV0, VSVSVSV1, VSVSVSV2)
      call loopVSVSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVSVSV0, SVVSVSV1, SVVSVSV2)
      call loopSVVSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(SVVVSVS0, SVVVSVS1, SVVVSVS2)
      call loopSVVVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VSVVSSV0, VSVVSSV1, VSVVSSV2)
      call loopVSVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case(VVSSVSV0, VVSSVSV1, VVSSVSV2)
      call loopVVSSVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4,  &
      PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop7

  subroutine computeLoop8(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, w6, P6, PL6, w7, P7, PL7, m, wp, riMaxIn, riMaxOut,      &
  rankInc)
    use class_vertices
    integer, intent(in) :: riMaxIn, riMaxOut, rankInc
    complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
    complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
    complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
    complex (kind = dp), intent(in), dimension(0:3) :: w2
    complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
    complex (kind = dp), intent(in), dimension(0:3) :: w3
    complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
    complex (kind = dp), intent(in), dimension(0:3) :: w4
    complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
    complex (kind = dp), intent(in), dimension(0:3) :: w5
    complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
    complex (kind = dp), intent(in), dimension(0:3) :: w6
    complex (kind = dp), intent(in), dimension(0:3) :: P7, PL7
    complex (kind = dp), intent(in), dimension(0:3) :: w7
    complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
    complex (kind = dp), intent(in) :: m
    complex (kind = dp), dimension(0:3) :: pl, p
    integer, intent(in) :: ty
    complex (kind = dp), dimension(0:), intent(in) :: co
    complex (kind = dp), dimension(0:3) :: sp1
    complex (kind = dp), dimension(0:3,0:3) :: sp2
    complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
    complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
    character(len=3) :: ty_str
    integer :: riOut, j
    logical :: isFirstRI
    integer :: mu, nu, ro, ta, te, tu
    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_loop_mdl')
    end select 
  end subroutine computeLoop8

end module class_loop
