!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl1()
    coupl(nGC_MI) = -cima
    coupl(nGC_MS) = -cMS*cima
    coupl(nGC_13) = -4d0*cggh*cima*gs**2d0/vev
    coupl(nGC_1348) = -gs
    coupl(nGC_1349) = -4d0*cima/vev**2d0
    coupl(nGC_12) = 4d0*cggh*gs/vev
    coupl(nGC_11) = 4d0*cggh*cima/vev
    coupl(nGC_10) = 4d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_22) = 4d0*cima/vev
    coupl(nGC_178) = -2d0*coupl(nGC_10)
    coupl(nGC_170) = -coupl(nGC_10)
    coupl(nGC_172) = 2d0*coupl(nGC_10)
    coupl(nGC_MU) = -cMU*cima
    coupl(nGC_2) = cima*gs
    coupl(nGC_MC) = -cMC*cima
    coupl(nGC_MB) = -cMB*cima
    coupl(nGC_26) = cima*gs
    coupl(nGC_14) = -3d0*cima*lam*vev/2d0
    coupl(nGC_1360) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_1361) = -4d0*gs/vev**2d0
    coupl(nGC_1362) = -16d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_1363) = -8d0*cima*gs**2d0/vev**3d0
    coupl(nGC_616) = -coupl(nGC_11)
    coupl(nGC_MD) = -cMD*cima
    coupl(nGC_1355) = -4d0*cima*gs**2d0/vev
    coupl(nGC_1354) = -8d0*cggh*cima*gs**2d0/vev
    coupl(nGC_1357) = 4d0*gs/vev
    coupl(nGC_1356) = 4d0*cggh*gs/vev
    coupl(nGC_1351) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_1350) = 8d0*cima/vev**3d0
    coupl(nGC_1353) = 2d0*cima*gs**2d0
    coupl(nGC_1352) = 8d0*gs/vev**3d0
    coupl(nGC_1359) = 4d0*cima*gs**2d0/vev**2d0
    coupl(nGC_1358) = 8d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_3) = cima*gs**2d0
    coupl(nGC_1) = -gs
    coupl(nGC_7) = -8d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_6) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_5) = 8d0*cggh*cima/vev**3d0
    coupl(nGC_4) = -3d0*cima*lam/2d0
    coupl(nGC_9) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_8) = -4d0*cggh*cima/vev**2d0
    coupl(nGC_118) = -2d0*coupl(nGC_13)
    coupl(nGC_112) = 2d0*coupl(nGC_13)
    coupl(nGC_110) = -coupl(nGC_13)
    coupl(nGC_52) = -coupl(nGC_8)
    coupl(nGC_368) = -coupl(nGC_5)
    coupl(nGC_252) = -2d0*coupl(nGC_3)
    coupl(nGC_246) = 2d0*coupl(nGC_3)
    coupl(nGC_244) = -coupl(nGC_3)
    coupl(nGC_164) = -coupl(nGC_1)
  end subroutine fill_couplings_mdl1
end module fill_couplings1
