!******************************************************************************!
!                                                                              !
!    ctparameter0.f90                                                          !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter0.f90                               |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter0
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter0()
  if (dMB_QCD2_scheme .eq. 0) then
    dMB_QCD2 = (pi**2d0*(-4d0*Nc*aS*cMB**2d0/(pi*rMB) + 4d0*Nc*aS*rMB/pi - Nc* &
               cMB*coupl(nGC_2)**2d0/(2d0*pi**2d0) + 4d0*aS*cMB**2d0/(pi*Nc*rMB&
               ) - 4d0*aS*rMB/(pi*Nc) + cMB*coupl(nGC_2)**2d0/(2d0*pi**2d0*Nc  &
               )) + Ten56*cMB*coupl(nGC_2)**2d0*(Nc**2d0 - 1d0)/Nc + Ten57*cMB*&
               coupl(nGC_2)**2d0*(-Nc**2d0 + 1d0)/Nc + 2d0*Ten58*coupl(nGC_2)**&
               2d0*rMB*(2d0*Nc**2d0*cMB**2d0 - 3d0*Nc**2d0*cMB*rMB + Nc**2d0*  &
               rMB**2d0 - 2d0*cMB**2d0 + 3d0*cMB*rMB - rMB**2d0)/Nc + 2d0*Ten59&
               *coupl(nGC_2)**2d0*rMB**2d0*(-Nc**2d0*cMB + Nc**2d0*rMB + cMB - &
               rMB)/Nc)/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMB_QCD2 = cone*real(dMB_QCD2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter0
end module ctparameter0
