!******************************************************************************!
!                                                                              !
!    ctparameter37.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter37.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter37
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter37()
  if (dZsR_QCD2_scheme .eq. 1) then
    dZsR_QCD2 = (pi**2d0*(-Nc*coupl(nGC_2)**2d0/(2d0*pi**2d0) + coupl(nGC_2)** &
                2d0/(2d0*pi**2d0*Nc)) + Ten52*coupl(nGC_2)**2d0*(Nc**2d0 - 1d0 &
                )/Nc + Ten53*coupl(nGC_2)**2d0*(Nc**2d0 - 1d0)/Nc + 2d0*Ten54* &
                cMS_reg**2d0*coupl(nGC_2)**2d0*(-Nc**2d0 + 1d0)/Nc + 2d0*Ten55*&
                cMS_reg**2d0*coupl(nGC_2)**2d0*(Nc**2d0 - 1d0)/Nc)/(16d0*pi**  &
                2d0)
    dZsR_QCD2 = cone*real(dZsR_QCD2,kind=dp)
  end if 
end subroutine set_ctparameter37
end module ctparameter37
