!******************************************************************************!
!                                                                              !
!    lcSVSVVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVSVVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopSVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVSVVS0)
!       c0*(Metric(2,4)*P(5,2) - Metric(2,4)*P(5,4) - Metric(2,5)*P(4,2) + Metric
!       (2,5)*P(4,5) + Metric(4,5)*P(2,4) - Metric(4,5)*P(2,5))
        x0 = w2(1)*w4(1)
        x1 = w2(2)*w4(2)
        x2 = w2(0)*w4(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P2(0)*w4(0)
        x6 = P5(1)*w4(1)
        x7 = P5(2)*w4(2)
        x8 = P2(1)*w4(1)
        x9 = P2(2)*w4(2)
        x10 = P5(0)*w4(0)
        x11 = P4(0)*w2(0)
        x12 = P5(1)*w2(1)
        x13 = P5(2)*w2(2)
        x14 = P4(1)*w2(1)
        x15 = P4(2)*w2(2)
        x16 = P5(0)*w2(0)
        x17 = w2(3)*w4(3)
        x18 = P2(0)*w5(0)
        x19 = P2(1)*w5(1)
        x20 = w2(2)*w5(2)
        x21 = P2(2)*w5(2)
        x22 = w2(1)*w5(1)
        x23 = P2(3)*w4(3)
        x24 = w4(1)*w5(1)
        x25 = w4(2)*w5(2)
        x26 = w4(0)*w5(0)
        x27 = P4(2)*w5(2)
        x28 = P4(3)*w2(3)
        x29 = w2(0)*w5(0)
        x30 = P5(3)*w4(3)
        x31 = P5(3)*w2(3)
        x32 = P4(0)*w5(0)
        wp(0,:) = cima*co(0)*w3(0)*wl(0,:)*(P4(1)*w5(1)*(x17 + x3) + w2(3)*w5(3&
                  )*(x10 - x5 - x6 - x7 + x8 + x9) + w4(3)*w5(3)*(x11 + x12 +  &
                  x13 - x14 - x15 - x16) + w5(3)*x4*(-P2(3) + P4(3)) + x0*(x18 &
                   - x21 + x27 - x32) + x1*(x18 - x19 - x32) + x10*(x20 + x22  &
                  ) + x11*x24 + x11*x25 + x12*x25 - x12*x26 + x13*x24 - x13*x26&
                   - x14*x25 + x14*x26 - x15*x24 + x15*x26 - x16*x24 - x16*x25 &
                   + x17*(x18 - x19 - x21 + x27 - x32) + x2*(x19 + x21 - x27   &
                  ) + x20*x23 - x20*x30 - x20*x5 - x20*x6 + x20*x8 + x22*x23 - &
                  x22*x30 - x22*x5 - x22*x7 + x22*x9 - x23*x29 - x24*x28 - x25*&
                  x28 + x26*x28 + x29*x30 + x29*x6 + x29*x7 - x29*x8 - x29*x9  &
                   + x31*(x24 + x25 - x26))
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVSVVS
end module lcSVSVVS
