!******************************************************************************!
!                                                                              !
!    lcSVVVVSS.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVVVVSS.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopSVVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVVVVSS0)
!       c0*(-Metric(2,3)*Metric(4,5) + 2*Metric(2,4)*Metric(3,5) - Metric(2,5)*  
!       Metric(3,4))
        x0 = w4(2)*w5(2)
        x1 = w4(0)*w5(0)
        x2 = w4(3)*w5(3) - x1
        x3 = w3(2)*w4(2)
        x4 = w3(3)*w4(3)
        x5 = w3(0)*w4(0)
        x6 = 2*w4(1)
        x7 = w3(0)*w5(0)
        x8 = w4(1)*w5(1)
        x9 = w3(1)*w4(1)
        x10 = 2*w4(2)
        x11 = w3(1)*w5(1)
        x12 = 2*w3(3)
        x13 = w2(0)*w3(0)
        x14 = w2(0)*w4(0)
        x15 = w2(0)*w5(0)
        x16 = w2(3)*w3(3)
        x17 = 2*w3(2)*w5(2)
        x18 = 2*w2(3)*w4(3)
        wp(0,:) = cima*co(0)*w6(0)*wl(0,:)*(-2*w2(0)*w4(0)*x11 - w2(1)*(w3(1)*(&
                  x0 + x2) + w5(1)*(x3 + x4 - x5) + x6*(-w3(2)*w5(2) - w3(3)*w5&
                  (3) + x7)) - w2(2)*(w3(2)*(x2 + x8) - w4(2)*w5(3)*x12 + w5(2 &
                  )*(x4 - x5 + x9) + x10*(-x11 + x7)) + w2(3)*w4(3)*x17 - w5(3 &
                  )*(w2(3)*(x3 - x5 + x9) - w4(3)*x13 + x12*x14) + x0*x13 - x0*&
                  x16 + x1*x16 + x11*x18 + x13*x8 - x14*x17 + x15*x3 + x15*x4  &
                   + x15*x9 - x16*x8 - x18*x7)
        wp(1:3,:) = cnul
      case(SVVVVSS1)
!       c0*(-Metric(2,3)*Metric(4,5) - Metric(2,4)*Metric(3,5) + 2*Metric(2,5)*  
!       Metric(3,4))
        x0 = w3(1)*w4(3)
        x1 = w3(3)*w4(1)
        x2 = w3(1)*w4(2)
        x3 = w3(2)*w4(1)
        x4 = w3(0)*w5(0)
        x5 = w4(0)*w5(0)
        x6 = 2*w5(1)
        x7 = w3(2)*w4(2)
        x8 = w3(3)*w4(3)
        x9 = 2*w3(0)*w4(0)
        x10 = w3(2)*w4(3)
        x11 = w3(3)*w4(2)
        x12 = 2*w5(2)
        x13 = w3(1)*w4(1)
        x14 = w2(0)*w3(0)
        x15 = w2(0)*w4(0)
        x16 = 2*w2(3)
        x17 = w2(3)*w5(1)
        x18 = w2(3)*w5(2)
        x19 = 2*w2(0)*w5(0)
        wp(0,:) = -cima*co(0)*w6(0)*wl(0,:)*(w2(1)*(-w3(1)*x5 - w4(1)*x4 + w5(1&
                  )*x9 + w5(2)*(x2 + x3) + w5(3)*(x0 + x1) - x6*(x7 + x8)) + w2&
                  (2)*(w3(0)*w4(0)*x12 - w3(2)*x5 - w4(2)*x4 + w5(1)*(x2 + x3  &
                  ) + w5(3)*(x10 + x11) - x12*(x13 + x8)) - w2(3)*w3(3)*x5 - w2&
                  (3)*w4(3)*x4 - w3(1)*w5(1)*x15 - w3(2)*w5(2)*x15 - w4(1)*w5(1&
                  )*x14 - w4(2)*w5(2)*x14 - w5(3)*(-w2(3)*x9 + w3(3)*x15 + w4(3&
                  )*x14 + x16*(x13 + x7)) + x0*x17 + x1*x17 + x10*x18 + x11*x18&
                   + x13*x19 + x19*x7 + x19*x8)
        wp(1:3,:) = cnul
      case(SVVVVSS2)
!       c0*(-2*Metric(2,3)*Metric(4,5) + Metric(2,4)*Metric(3,5) + Metric(2,5)*  
!       Metric(3,4))
        x0 = w4(0)*w5(1)
        x1 = w4(1)*w5(0)
        x2 = w4(2)*w5(2)
        x3 = w4(3)*w5(3)
        x4 = w4(0)*w5(0)
        x5 = x3 - x4
        x6 = w4(1)*w5(2)
        x7 = w4(2)*w5(1)
        x8 = w3(3)*w5(3)
        x9 = w3(3)*w4(3)
        x10 = w4(0)*w5(2)
        x11 = w4(2)*w5(0)
        x12 = w4(1)*w5(1)
        x13 = w2(3)*w5(3)
        x14 = w2(3)*w4(3)
        x15 = w2(0)*w3(1)
        x16 = w2(0)*w3(2)
        x17 = 2*w2(3)*w3(3)
        x18 = 2*w2(0)*w3(0)
        wp(0,:) = cima*co(0)*w6(0)*wl(0,:)*(-w2(0)*w4(0)*x8 - w2(0)*w5(0)*x9 + &
                  w2(1)*(-w3(0)*(x0 + x1) - 2*w3(1)*(x2 + x5) + w3(2)*(x6 + x7 &
                  ) + w4(1)*x8 + w5(1)*x9) + w2(2)*(-w3(0)*(x10 + x11) + w3(1  &
                  )*(x6 + x7) - 2*w3(2)*(x12 + x5) + w4(2)*x8 + w5(2)*x9) - w3(&
                  0)*w4(0)*x13 - w3(0)*w5(0)*x14 + w3(1)*w4(1)*x13 + w3(1)*w5(1&
                  )*x14 + w3(2)*w4(2)*x13 + w3(2)*w5(2)*x14 - x12*x17 + x12*x18&
                   - x15*(x0 + x1) - x16*(x10 + x11) - x17*x2 + x17*x4 + x18*x2&
                   + x18*x3)
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVVVVSS
end module lcSVVVVSS
