!******************************************************************************!
!                                                                              !
!    lcVSVVSS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVVSS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopVSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVVSS0)
!       c0*(Metric(1,3)*P(4,1) - Metric(1,3)*P(4,3) - Metric(1,4)*P(3,1) + Metric
!       (1,4)*P(3,4) + Metric(3,4)*P(1,3) - Metric(3,4)*P(1,4))
        x0 = w3(1)*w4(1)
        x1 = w3(2)*w4(2)
        x2 = w3(0)*w4(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P1(0)*w3(0)
        x6 = P4(1)*w3(1)
        x7 = P4(2)*w3(2)
        x8 = P1(1)*w3(1)
        x9 = P1(2)*w3(2)
        x10 = P4(0)*w3(0)
        x11 = P1(0)*w4(0)
        x12 = P3(1)*w4(1)
        x13 = P3(2)*w4(2)
        x14 = P1(1)*w4(1)
        x15 = P1(2)*w4(2)
        x16 = P3(0)*w4(0)
        x17 = w3(3)*w4(3)
        x23 = P1(3)*w4(3)
        x24 = P1(3)*w3(3)
        x29 = P3(3)*w4(3)
        x32 = P4(3)*w3(3)
        x34 = cima*co(0)*w2(0)*w5(0)
        do j = riMaxIn, 0, -1
          x18 = w3(1)*wl(1,j)
          x19 = w3(2)*wl(2,j)
          x20 = w3(0)*wl(0,j)
          x21 = w4(2)*wl(2,j)
          x22 = w4(1)*wl(1,j)
          x25 = w3(3)*w4(2)*wl(2,j)
          x26 = P3(0)*wl(0,j)
          x27 = P3(1)*wl(1,j)
          x28 = P3(2)*wl(2,j)
          x30 = w4(0)*wl(0,j)
          x31 = P4(2)*wl(2,j)
          x33 = P4(0)*wl(0,j)
          wp(0,j) = x34*(P1(3)*x25 + P4(1)*wl(1,j)*(x17 + x3) - P4(3)*x25 + w3(&
                    3)*wl(3,j)*(x11 + x12 + x13 - x14 - x15 - x16) + w4(3)*wl(3&
                    ,j)*(x10 - x5 - x6 - x7 + x8 + x9) + wl(3,j)*x4*(-P3(3) +  &
                    P4(3)) + x0*(x26 - x28 + x31 - x33) + x1*(x26 - x27 - x33  &
                    ) + x10*(x21 + x22) + x11*x18 + x11*x19 + x12*x19 - x12*x20&
                     + x13*x18 - x13*x20 - x14*x19 + x14*x20 - x15*x18 + x15*  &
                    x20 - x16*x18 - x16*x19 + x17*(x26 - x27 - x28 + x31 - x33 &
                    ) - x18*x23 - x19*x23 + x2*(x27 + x28 - x31) + x20*x23 -   &
                    x21*(x5 + x6 - x8) + x22*x24 - x22*x32 - x22*x5 - x22*x7 + &
                    x22*x9 - x24*x30 + x29*(x18 + x19 - x20) + x30*x32 + x30*x6&
                     + x30*x7 - x30*x8 - x30*x9)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w3(mu)*x34*(w4(3)*wl(3,j) + x21 + x22  &
                           - x30) + w4(mu)*x34*(w3(3)*wl(3,j) + x18 + x19 - x20&
                          )
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVVSS
end module lcVSVVSS
