!******************************************************************************!
!                                                                              !
!    lcVSVVSSV.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVVSSV.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVVSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopVSVVSSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVVSSV0)
!       c0*(-Metric(1,3)*Metric(4,7) - Metric(1,4)*Metric(3,7) + 2*Metric(1,7)*  
!       Metric(3,4))
        do j = riMaxIn, 0, -1
          wp(:,j) = -cima*co(0)*w2(0)*w5(0)*w6(0)*(w3(:)*(-w4(0)*wl(0,j) + w4(1&
                    )*wl(1,j) + w4(2)*wl(2,j) + w4(3)*wl(3,j)) + w4(:)*(-w3(0)*&
                    wl(0,j) + w3(1)*wl(1,j) + w3(2)*wl(2,j) + w3(3)*wl(3,j)) - &
                    wl(:,j)*(-2*w3(0)*w4(0) + 2*w3(1)*w4(1) + 2*w3(2)*w4(2) + 2&
                    *w3(3)*w4(3)))
        end do 
      case(VSVVSSV1)
!       c0*(-Metric(1,3)*Metric(4,7) + 2*Metric(1,4)*Metric(3,7) - Metric(1,7)*  
!       Metric(3,4))
        do j = riMaxIn, 0, -1
          wp(:,j) = -cima*co(0)*w2(0)*w5(0)*w6(0)*(-2*w3(:)*(-w4(0)*wl(0,j) +  &
                    w4(1)*wl(1,j) + w4(2)*wl(2,j) + w4(3)*wl(3,j)) + w4(:)*(-w3&
                    (0)*wl(0,j) + w3(1)*wl(1,j) + w3(2)*wl(2,j) + w3(3)*wl(3,j &
                    )) + wl(:,j)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3&
                    (3)*w4(3)))
        end do 
      case(VSVVSSV2)
!       c0*(-2*Metric(1,3)*Metric(4,7) + Metric(1,4)*Metric(3,7) + Metric(1,7)*  
!       Metric(3,4))
        do j = riMaxIn, 0, -1
          wp(:,j) = cima*co(0)*w2(0)*w5(0)*w6(0)*(w3(:)*(-w4(0)*wl(0,j) + w4(1 &
                    )*wl(1,j) + w4(2)*wl(2,j) + w4(3)*wl(3,j)) - 2*w4(:)*(-w3(0&
                    )*wl(0,j) + w3(1)*wl(1,j) + w3(2)*wl(2,j) + w3(3)*wl(3,j   &
                    )) + wl(:,j)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3&
                    (3)*w4(3)))
        end do 
      end select 
    end subroutine loopVSVVSSV
end module lcVSVVSSV
