!******************************************************************************!
!                                                                              !
!    lcVSVVVSS.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVVVSS.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopVSVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVVVSS0)
!       c0*(-2*Metric(1,3)*Metric(4,5) + Metric(1,4)*Metric(3,5) + Metric(1,5)*  
!       Metric(3,4))
        x3 = w4(2)*w5(1)
        x6 = 2*w4(2)*w5(2)
        x7 = 2*w4(3)*w5(3)
        x8 = 2*w4(0)*w5(0)
        x10 = 2*w4(1)*w5(1)
        x11 = w3(0)*w4(0)
        x12 = w3(0)*w5(0)
        x13 = 2*w3(3)
        x14 = w3(3)*w5(3)
        x16 = w3(3)*w4(3)
        do j = riMaxIn, 0, -1
          x0 = w5(2)*wl(2,j)
          x1 = w5(3)*wl(3,j)
          x2 = w5(0)*wl(0,j)
          x4 = w4(3)*wl(3,j)
          x5 = w4(0)*wl(0,j)
          x9 = w4(1)*wl(1,j)
          x15 = w4(2)*wl(2,j)
          x17 = w5(1)*wl(1,j)
          x18 = w3(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w2(0)*w6(0)*(w3(1)*(w4(1)*(x0 + x1 - x2) + w5(1 &
                    )*(x4 - x5) - wl(1,j)*(x6 + x7 - x8) + wl(2,j)*x3) + w3(2  &
                    )*(w4(2)*(x1 - x2) + w5(2)*(x4 - x5 + x9) + wl(1,j)*x3 - wl&
                    (2,j)*(x10 + x7 - x8)) + w4(0)*w5(0)*wl(3,j)*x13 - w4(3)*wl&
                    (3,j)*x12 - w5(3)*wl(3,j)*x11 - wl(3,j)*x13*(w4(1)*w5(1) + &
                    w4(2)*w5(2)) - x12*x15 - x12*x9 + x14*x15 - x14*x5 + x14*x9&
                     - x16*x2 + x18*(x10 + x6 + x7) - (x0 + x17)*(x11 - x16))
        end do 
        wp(1:3,:) = cnul
      case(VSVVVSS1)
!       c0*(-Metric(1,3)*Metric(4,5) - Metric(1,4)*Metric(3,5) + 2*Metric(1,5)*  
!       Metric(3,4))
        x6 = w4(2)*w5(2)
        x8 = w4(3)*w5(3)
        x13 = w3(0)*w4(3)
        x14 = w3(3)*w4(0)
        x15 = 2*w3(0)*w4(0)
        x16 = w3(3)*w5(3)
        x17 = w3(0)*w4(1)
        x18 = w3(0)*w4(2)
        x20 = 2*w3(3)*w4(3)
        do j = riMaxIn, 0, -1
          x0 = w5(0)*wl(1,j)
          x1 = w5(1)*wl(0,j)
          x2 = w5(2)*wl(2,j)
          x3 = w5(0)*wl(0,j)
          x4 = w5(3)*wl(3,j) - x3
          x5 = w5(1)*wl(2,j)
          x7 = w4(3)*wl(3,j)
          x9 = w5(0)*wl(2,j)
          x10 = w5(2)*wl(0,j)
          x11 = w5(1)*wl(1,j)
          x12 = w4(1)*wl(1,j)
          x19 = w5(3)*wl(0,j)
          wp(0,j) = -cima*co(0)*w2(0)*w6(0)*(w3(1)*(-w4(0)*(x0 + x1) - 2*w4(1  &
                    )*(x2 + x4) + w4(2)*x5 + w5(1)*x7 + wl(1,j)*(x6 + x8)) + w3&
                    (2)*(-w4(0)*(x10 + x9) + w4(1)*x5 - 2*w4(2)*(x11 + x4) + w5&
                    (2)*(x12 + x7) + wl(2,j)*x8) + w4(2)*wl(2,j)*x16 + wl(3,j  &
                    )*(w3(3)*(w4(1)*w5(1) + x6) - w5(0)*(x13 + x14) + w5(3)*x15&
                    ) - x0*x17 - x1*x17 - x10*x18 + x11*x15 - x11*x20 + x12*x16&
                     - x13*x19 - x14*x19 + x15*x2 - x18*x9 - x2*x20 + x20*x3)
        end do 
        wp(1:3,:) = cnul
      case(VSVVVSS2)
!       c0*(-Metric(1,3)*Metric(4,5) + 2*Metric(1,4)*Metric(3,5) - Metric(1,5)*  
!       Metric(3,4))
        x3 = w4(2)*w5(2)
        x4 = w4(3)*w5(3)
        x5 = w4(0)*w5(0)
        x10 = w4(1)*w5(1)
        x12 = w3(0)*w4(0)
        x13 = w3(0)*w5(0)
        x15 = w3(3)*w4(3)
        x16 = w3(3)*w5(3)
        do j = riMaxIn, 0, -1
          x0 = w5(2)*wl(2,j)
          x1 = w5(0)*wl(0,j)
          x2 = w5(3)*wl(3,j) - x1
          x6 = 2*w4(2)*wl(2,j)
          x7 = 2*w4(3)*wl(3,j)
          x8 = 2*w4(0)*wl(0,j)
          x9 = w5(1)*wl(1,j)
          x11 = 2*w4(1)*wl(1,j)
          x14 = w3(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w2(0)*w6(0)*(-w3(1)*w4(1)*(x0 + x2) + w3(1)*w5(1&
                    )*(x6 + x7 - x8) - w3(1)*wl(1,j)*(x3 + x4 - x5) - w3(2)*w4(&
                    2)*(x2 + x9) + w3(2)*w5(2)*(x11 + x7 - x8) - w3(2)*wl(2,j  &
                    )*(x10 + x4 - x5) - w3(3)*wl(3,j)*(x10 + x3 - x5) - 2*w4(3 &
                    )*wl(3,j)*x13 + w5(3)*wl(3,j)*x12 + x0*x12 - x0*x15 + x1*  &
                    x15 + x10*x14 - x11*x13 + x11*x16 + x12*x9 - x13*x6 + x14* &
                    x3 + x14*x4 - x15*x9 + x16*x6 - x16*x8)
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVVVSS
end module lcVSVVVSS
