!******************************************************************************!
!                                                                              !
!    lcVVVSSVS.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVVSSVS.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVVSSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35
  complex (dp), dimension(0:3) :: x0vec, x1vec
  contains
    subroutine loopVVVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVVSSVS0)
!       c0*(-Metric(1,2)*Metric(3,6) - Metric(1,3)*Metric(2,6) + 2*Metric(1,6)*  
!       Metric(2,3))
        x7 = w3(3)*w6(3)
        x11 = w3(1)*w6(1)
        x12 = w2(3)*w3(2)
        x13 = w2(3)*w3(0)
        x14 = 2*w2(0)*w3(0)
        x15 = w2(0)*w3(1)
        x16 = w2(0)*w3(2)
        x17 = 2*w2(3)*w3(3)
        do j = riMaxIn, 0, -1
          x0 = w6(0)*wl(1,j)
          x1 = w6(1)*wl(0,j)
          x2 = w6(2)*wl(2,j)
          x3 = w6(0)*wl(0,j)
          x4 = w6(3)*wl(3,j) - x3
          x5 = w6(2)*wl(1,j)
          x6 = w3(3)*wl(3,j)
          x8 = w6(0)*wl(2,j)
          x9 = w6(2)*wl(0,j)
          x10 = w6(1)*wl(1,j)
          wp(0,j) = -cima*co(0)*w4(0)*w5(0)*(-w2(0)*wl(0,j)*x7 + w2(1)*(-w3(0  &
                    )*(x0 + x1) - 2*w3(1)*(x2 + x4) + w3(2)*(w6(1)*wl(2,j) + x5&
                    ) + w6(1)*x6 + wl(1,j)*x7) + w2(2)*(-w3(0)*(x8 + x9) + w3(1&
                    )*x5 - 2*w3(2)*(x10 + x4) + w6(2)*x6 + wl(2,j)*(x11 + x7   &
                    )) + w2(3)*w3(1)*w6(3)*wl(1,j) - w6(3)*wl(0,j)*x13 + w6(3)*&
                    wl(2,j)*x12 + wl(3,j)*(w2(3)*x11 - w6(0)*(w2(0)*w3(3) + x13&
                    ) + w6(2)*x12 + w6(3)*x14) - x0*x15 - x1*x15 + x10*x14 -   &
                    x10*x17 + x14*x2 - x16*x8 - x16*x9 - x17*x2 + x17*x3)
        end do 
        wp(1:3,:) = cnul
      case(VVVSSVS1)
!       c0*(-Metric(1,2)*Metric(3,6) + 2*Metric(1,3)*Metric(2,6) - Metric(1,6)*  
!       Metric(2,3))
        x3 = w3(2)*w6(2)
        x4 = w3(3)*w6(3)
        x5 = w3(0)*w6(0)
        x6 = 2*w6(1)
        x11 = w3(1)*w6(1)
        x12 = 2*w6(2)
        x14 = w2(0)*w3(0)
        x15 = 2*w2(0)*w6(0)
        x17 = w2(3)*w3(3)
        x18 = 2*w2(3)*w6(3)
        do j = riMaxIn, 0, -1
          x0 = w6(2)*wl(2,j)
          x1 = w6(0)*wl(0,j)
          x2 = w6(3)*wl(3,j) - x1
          x7 = w3(2)*wl(2,j)
          x8 = w3(3)*wl(3,j)
          x9 = w3(0)*wl(0,j)
          x10 = w6(1)*wl(1,j)
          x13 = w3(1)*wl(1,j)
          x16 = w2(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w4(0)*w5(0)*(-w2(1)*(w3(1)*(x0 + x2) + wl(1,j)*(&
                    x3 + x4 - x5) - x6*(x7 + x8 - x9)) - w2(2)*(w3(2)*(x10 + x2&
                    ) + wl(2,j)*(x11 + x4 - x5) - x12*(x13 + x8 - x9)) - wl(3,j&
                    )*(w2(3)*(x11 + x3 - x5) + w3(3)*x15 - w6(3)*x14) + x0*x14 &
                     - x0*x17 + x1*x17 + x10*x14 - x10*x17 + x11*x16 - x13*x15 &
                     + x13*x18 - x15*x7 + x16*x3 + x16*x4 + x18*x7 - x18*x9)
        end do 
        wp(1:3,:) = cnul
      case(VVVSSVS2)
!       c0*(-2*Metric(1,2)*Metric(3,6) + Metric(1,3)*Metric(2,6) + Metric(1,6)*  
!       Metric(2,3))
        x3 = w3(2)*w6(1)
        x7 = w3(2)*w6(2)
        x8 = w3(3)*w6(3)
        x9 = w3(0)*w6(0)
        x12 = w3(1)*w6(1)
        x13 = w2(0)*w3(0)
        x14 = w2(0)*w6(0)
        x15 = 2*w2(3)
        x16 = w2(3)*w6(3)
        x18 = w2(3)*w3(3)
        do j = riMaxIn, 0, -1
          x0 = w6(2)*wl(2,j)
          x1 = w6(3)*wl(3,j)
          x2 = w6(0)*wl(0,j)
          x4 = w3(3)*wl(3,j)
          x5 = w3(0)*wl(0,j)
          x6 = 2*wl(1,j)
          x10 = w3(1)*wl(1,j)
          x11 = 2*wl(2,j)
          x17 = w3(2)*wl(2,j)
          x19 = w6(1)*wl(1,j)
          x20 = 2*w2(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w4(0)*w5(0)*(w2(1)*(w3(1)*(x0 + x1 - x2) + w6(1 &
                    )*(x4 - x5) + wl(2,j)*x3 - x6*(x7 + x8 - x9)) + w2(2)*(w3(2&
                    )*(x1 - x2) + w6(2)*(x10 + x4 - x5) + wl(1,j)*x3 - x11*(x12&
                     + x8 - x9)) - wl(3,j)*x12*x15 - wl(3,j)*x15*x7 + wl(3,j)* &
                    x15*x9 - wl(3,j)*(w3(3)*x14 + w6(3)*x13) + x12*x20 - x16*x5&
                     - x18*x2 + x20*x7 + x20*x8 - (x0 + x19)*(x13 - x18) - (x10&
                     + x17)*(x14 - x16))
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVVSSVS
end module lcVVVSSVS
