!******************************************************************************!
!                                                                              !
!    tcFFaS.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFFaS.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFFaS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeFFaS(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FFaS0)
!       c0*(2*GammaP(-1,2,1)*P(-1,2) + GammaP(-1,2,1)*P(-1,3))
!       c1*(2*GammaM(-1,2,1)*P(-1,2) + GammaM(-1,2,1)*P(-1,3))
!       ProjP(2,1)*c2
!       ProjM(2,1)*c3
        x0 = P2(2)*cima
        x1 = P1(2)*cima
        x2 = P1(1) - P2(1)
        x3 = x0 - x1 + x2
        x4 = co(0)*w1(1)
        x5 = P1(0) - P2(0)
        x6 = -P1(3) + P2(3) + x5
        x7 = co(0)*w1(0)
        x8 = -x0 + x1 + x2
        x9 = P1(3) - P2(3) + x5
        wout(0) = -co(1)*w2(0)*(w1(2)*x9 + w1(3)*x3) - co(1)*w2(1)*(w1(2)*x8 + &
                  w1(3)*x6) + co(2)*(w1(0)*w2(0) + w1(1)*w2(1)) + w2(2)*(co(3)*&
                  w1(2) + x3*x4 - x6*x7) + w2(3)*(co(3)*w1(3) - x4*x9 + x7*x8)
        wout(1:3) = cnul
      end select 
    end subroutine treeFFaS
end module tcFFaS
