!******************************************************************************!
!                                                                              !
!    tcFSSFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFSSFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFSSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeFSSFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FSSFa0)
!       c0*(GammaP(-1,4,1)*P(-1,1)/2 + GammaP(-1,4,1)*P(-1,2) + GammaP(-1,4,1)*P 
!       (-1,3))
!       c1*(GammaM(-1,4,1)*P(-1,1)/2 + GammaM(-1,4,1)*P(-1,2) + GammaM(-1,4,1)*P 
!       (-1,3))
!       ProjP(4,1)*c2
!       ProjM(4,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = 2*P2(2)
      x1 = 2*P3(2)
      x2 = 2*P2(1)
      x3 = 2*P3(1)
      x4 = cima*(P1(2) + cima*x2 + cima*x3 + x0 + x1)
      x5 = P1(1) - x4
      x6 = 2*P2(3)
      x7 = 2*P3(3)
      x8 = P1(0) + 2*P2(0) + 2*P3(0)
      x9 = P1(3) + x6 + x7 + x8
      x10 = co(0)*w1(1)
      x11 = -P1(3) - x6 - x7 + x8
      x12 = pl(0)*x11
      x13 = P1(1) + P1(2)*cima + cima*x0 + cima*x1 + x2 + x3
      x14 = pl(3)*x13
      x15 = co(0)*w1(0)
      x16 = 2*co(3)
      x17 = 2*co(2)*m
      x18 = co(1)*m
      x19 = w2(0)*w3(0)/2
      x20 = pl(1)*x9
      x21 = pl(2)*x5
      x22 = m*x16
      x23 = 2*co(2)
      x24 = co(0)*m
      wout(0) = x19*(-pl(0)*w1(2)*x16 - pl(3)*w1(3)*x16 + w1(0)*x17 + w1(2)*x18&
                *x9 + w1(3)*x18*x5 + x10*(pl(0)*x5 - pl(3)*x9) - x15*(x12 - x14&
                ))
      wout(1) = x19*(w1(1)*x17 - x10*(x20 - x21) + x15*(pl(1)*x13 - pl(2)*x11  &
                ) - x16*(pl(1)*w1(3) + pl(2)*w1(2)) + x18*(w1(2)*x13 + w1(3)*  &
                x11))
      wout(2) = x19*(co(1)*w1(3)*(-P1(1)*pl(1) + pl(1)*x4 + pl(3)*x11) + w1(2  &
                )*(co(1)*x14 - co(1)*x20 + x22) - x23*(pl(1)*w1(0) - pl(3)*w1(1&
                )) + x24*(w1(0)*x11 - w1(1)*x5))
      wout(3) = -x19*(co(1)*w1(2)*(pl(0)*x13 - pl(2)*x9) - w1(3)*(-co(1)*x12 + &
                co(1)*x21 + x22) + x23*(pl(0)*w1(1) - pl(2)*w1(0)) + x24*(w1(0 &
                )*x13 - w1(1)*x9))
    else
      x0 = 2*co(2)
      x1 = 2*P2(3)
      x2 = 2*P3(3)
      x3 = P1(0) + 2*P2(0) + 2*P3(0)
      x4 = P1(3) + x1 + x2 + x3
      x5 = co(1)*w1(2)
      x6 = 2*P2(2)
      x7 = 2*P3(2)
      x8 = 2*P2(1)
      x9 = 2*P3(1)
      x10 = P1(1) - cima*(P1(2) + cima*x8 + cima*x9 + x6 + x7)
      x11 = co(1)*w1(3)
      x12 = w2(0)*w3(0)/2
      x13 = P1(1) + P1(2)*cima + cima*x6 + cima*x7 + x8 + x9
      x14 = -P1(3) - x1 - x2 + x3
      x15 = 2*co(3)
      x16 = co(0)*w1(0)
      x17 = co(0)*w1(1)
      wout(0) = x12*(w1(0)*x0 + x10*x11 + x4*x5)
      wout(1) = x12*(w1(1)*x0 + x11*x14 + x13*x5)
      wout(2) = x12*(w1(2)*x15 - x10*x17 + x14*x16)
      wout(3) = x12*(w1(3)*x15 - x13*x16 + x17*x4)
    end if 
      end select 
    end subroutine treeFSSFa
end module tcFSSFa
