!******************************************************************************!
!                                                                              !
!    tcFaSSF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaSSF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaSSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeFaSSF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaSSF0)
!       c0*(GammaP(-1,1,4)*P(-1,2) + GammaP(-1,1,4)*P(-1,3) + GammaP(-1,1,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,1,4)*P(-1,2) + GammaM(-1,1,4)*P(-1,3) + GammaM(-1,1,4)*P(-1
!       ,4)/2)
!       ProjP(1,4)*c2
!       ProjM(1,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = -P1(3) + P2(3) + P3(3)
      x1 = -P1(0) + P2(0) + P3(0) + x0
      x2 = pl(1)*x1
      x3 = P1(2)*cima
      x4 = -x3
      x5 = P1(1) - P2(1) + x4
      x6 = cima*(P2(2) + P3(1)*cima + P3(2)) + x5
      x7 = pl(2)*x6
      x8 = co(1)*w1(0)
      x9 = P2(2)*cima
      x10 = P3(2)*cima
      x11 = P2(1) + P3(1) + x10 + x9
      x12 = -P1(1) + x11 + x4
      x13 = P1(0) - P2(0) - P3(0) + x0
      x14 = co(1)*w1(1)
      x15 = 2*co(3)*w1(3)
      x16 = 2*co(2)*m
      x17 = 2*co(3)*w1(2)
      x18 = co(0)*(P1(1) + cima*(P1(2) + cima*x11))
      x19 = co(0)*m*w1(2)
      x20 = w2(0)*w3(0)/2
      x21 = pl(0)*x13
      x22 = -P3(1) + x10 + x5 + x9
      x23 = co(0)*w1(3)
      x24 = 2*co(3)*m
      x25 = 2*co(2)
      x26 = co(1)*m
      wout(0) = x20*(m*w1(3)*x18 + pl(1)*x17 - pl(2)*x15 + w1(0)*x16 - x13*x19 &
                 + x14*(pl(1)*x12 + pl(2)*x13) + x8*(x2 + x7))
      wout(1) = x20*(m*x1*x23 + pl(0)*x15 - pl(3)*x17 + w1(1)*x16 - x14*(pl(3)*&
                x12 + x21) + x19*x22 - x8*(pl(0)*x6 + pl(3)*x1))
      wout(2) = x20*(w1(2)*(-co(0)*x21 + co(0)*x7 + x24) + x23*(P1(1)*pl(0) -  &
                pl(0)*x11 + pl(0)*x3 + pl(2)*x1) + x25*(pl(0)*w1(0) + pl(2)*w1(&
                1)) + x26*(w1(0)*x1 + w1(1)*x12))
      wout(3) = x20*(co(0)*w1(2)*(pl(1)*x6 - pl(3)*x13) + w1(3)*(co(0)*x2 + pl(&
                3)*x18 + x24) + x25*(pl(1)*w1(1) + pl(3)*w1(0)) - x26*(w1(0)*  &
                x22 + w1(1)*x13))
    else
      x0 = -P1(3) + P2(3) + P3(3)
      x1 = P1(0) - P2(0) - P3(0) + x0
      x2 = -P1(2)*cima
      x3 = P2(2)*cima + P3(2)*cima
      x4 = -P1(1) + P2(1) + P3(1) + x2 + x3
      x5 = 2*co(2)
      x6 = w2(0)*w3(0)/2
      x7 = -P2(1)
      x8 = -P1(0) + P2(0) + P3(0) + x0
      x9 = 2*co(3)
      x10 = co(1)*w1(0)
      x11 = co(1)*w1(1)
      wout(0) = x6*(-co(0)*(w1(2)*x1 + w1(3)*x4) + w1(0)*x5)
      wout(1) = x6*(co(0)*w1(2)*(P1(1) + cima*(P2(2) + P3(1)*cima + P3(2)) + x2&
                 + x7) + co(0)*w1(3)*x8 + w1(1)*x5)
      wout(2) = x6*(w1(2)*x9 + x10*x8 + x11*x4)
      wout(3) = -x6*(-w1(3)*x9 + x1*x11 + x10*(P1(1) - P3(1) + x2 + x3 + x7))
    end if 
      end select 
    end subroutine treeFaSSF
end module tcFaSSF
