!******************************************************************************!
!                                                                              !
!    tcFaVSSF.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaVSSF.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaVSSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeFaVSSF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaVSSF0)
!       GammaP(2,1,5)*c0
!       GammaM(2,1,5)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:) + PL4(:)
      x0 = cima*w2(2)
      x1 = -w1(0)*w2(1) + w1(0)*x0 - w1(1)*w2(0) + w1(1)*w2(3)
      x2 = w2(0) + w2(3)
      x3 = w1(0)*x2
      x4 = w2(1) + x0
      x5 = w1(1)*x4
      x6 = w2(0) - w2(3)
      x7 = co(0)*(w1(2)*x6 - w1(3)*x4)
      x8 = w3(0)*w4(0)
      x9 = -w2(1) + x0
      x10 = co(0)*(w1(2)*x9 + w1(3)*x2)
      x11 = co(1)*m
      wout(0) = -x8*(co(1)*(pl(1)*x3 + pl(1)*x5 + pl(2)*x1) + m*x7)
      wout(1) = x8*(co(1)*(pl(0)*x1 + pl(3)*x3 + pl(3)*x5) - m*x10)
      wout(2) = -x8*(pl(0)*x7 + pl(2)*x10 + x11*x3 + x11*x5)
      wout(3) = -x8*(pl(1)*x10 + pl(3)*x7 - w1(0)*x11*x9 + w1(1)*x11*x6)
    else
      x0 = cima*w2(2)
      x1 = w2(1) + x0
      x2 = co(0)*w3(0)*w4(0)
      x3 = w2(0) + w2(3)
      x4 = co(1)*w3(0)*w4(0)
      wout(0) = -x2*(w1(2)*(w2(0) - w2(3)) - w1(3)*x1)
      wout(1) = -x2*(w1(2)*(-w2(1) + x0) + w1(3)*x3)
      wout(2) = -x4*(w1(0)*x3 + w1(1)*x1)
      wout(3) = x4*(-w1(0)*w2(1) + w1(0)*x0 - w1(1)*w2(0) + w1(1)*w2(3))
    end if 
      end select 
    end subroutine treeFaVSSF
end module tcFaVSSF
