!******************************************************************************!
!                                                                              !
!    tcSFSVFa.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFSVFa.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFSVFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSFSVFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFSVFa0)
!       GammaP(4,5,2)*c0
!       GammaM(4,5,2)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:) + PL4(:)
      x0 = w4(0) - w4(3)
      x1 = w2(0)*x0
      x2 = cima*w4(2)
      x3 = -w4(1) + x2
      x4 = w2(1)*x3
      x5 = w4(0) + w4(3)
      x6 = w2(1)*x5
      x7 = w4(1) + x2
      x8 = w2(0)*x7
      x9 = w2(2)*x5
      x10 = w2(3)*x3
      x11 = co(1)*m
      x12 = w1(0)*w3(0)
      x13 = w2(2)*x7 + w2(3)*x0
      x14 = co(0)*m
      wout(0) = -x12*(-co(0)*(pl(0)*x1 + pl(0)*x4 + pl(3)*x6 - pl(3)*x8) + x11 &
                *(-x10 + x9))
      wout(1) = -x12*(-co(0)*(pl(1)*x6 - pl(1)*x8 + pl(2)*x1 + pl(2)*x4) + x11*&
                x13)
      wout(2) = -x12*(co(1)*(pl(1)*x10 - pl(1)*x9 + pl(3)*x13) + x14*(x1 + x4))
      wout(3) = x12*(-co(1)*(-pl(0)*x13 - pl(2)*x10 + pl(2)*x9) + x14*(-x6 + x8&
                ))
    else
      x0 = w4(0) + w4(3)
      x1 = cima*w4(2)
      x2 = -w4(1) + x1
      x3 = co(1)*w1(0)*w3(0)
      x4 = w4(1) + x1
      x5 = w4(0) - w4(3)
      x6 = co(0)*w1(0)*w3(0)
      wout(0) = -x3*(w2(2)*x0 - w2(3)*x2)
      wout(1) = -x3*(w2(2)*x4 + w2(3)*x5)
      wout(2) = -x6*(w2(0)*x5 + w2(1)*x2)
      wout(3) = x6*(w2(0)*x4 - w2(1)*x0)
    end if 
      end select 
    end subroutine treeSFSVFa
end module tcSFSVFa
