!******************************************************************************!
!                                                                              !
!    tcSFaF.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFaF.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFaF0)
!       c0*(GammaP(-1,2,3)*P(-1,1) + 2*GammaP(-1,2,3)*P(-1,2))
!       c1*(GammaM(-1,2,3)*P(-1,1) + 2*GammaM(-1,2,3)*P(-1,2))
!       ProjP(2,3)*c2
!       ProjM(2,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = 2*P2(3)
      x1 = P1(0) + 2*P2(0)
      x2 = -P1(3) - x0 + x1
      x3 = co(0)*m
      x4 = P1(2)*cima
      x5 = 2*P2(2)
      x6 = cima*x5
      x7 = 2*P2(1)
      x8 = P1(1) + x7
      x9 = x4 + x6 + x8
      x10 = P1(3) + x0 + x1
      x11 = pl(1)*x10
      x12 = co(1)*w2(0)
      x13 = co(1)*w2(1)
      x14 = co(2)*m
      x15 = cima*(P1(2) + cima*x7 + x5)
      x16 = pl(0)*x2
      x17 = pl(3)*x9
      x18 = co(0)*w2(2)
      x19 = co(1)*m
      x20 = co(3)*m
      wout(0) = w1(0)*(w2(0)*x14 + w2(2)*(co(3)*pl(1) + x2*x3) - w2(3)*(co(3)* &
                pl(2) + x3*x9) + x12*(-pl(2)*(-x4 - x6 + x8) + x11) + x13*(pl(1&
                )*x9 - pl(2)*x2))
      wout(1) = w1(0)*(co(3)*pl(0)*w2(3) - co(3)*pl(3)*w2(2) + w2(1)*x14 - x12 &
                *(-P1(1)*pl(0) + pl(0)*x15 + pl(3)*x10) + x13*(x16 - x17) + x3 &
                *(-P1(1)*w2(2) + w2(2)*x15 + w2(3)*x10))
      wout(2) = w1(0)*(-co(0)*w2(3)*(pl(0)*x9 - pl(2)*x10) + co(2)*(pl(0)*w2(0 &
                ) + pl(2)*w2(1)) + w2(2)*x20 + x18*(-P1(1)*pl(2) + pl(2)*x15 + &
                x16) + x19*(w2(0)*x10 + w2(1)*x9))
      wout(3) = w1(0)*(co(2)*(pl(1)*w2(1) + pl(3)*w2(0)) + w2(3)*(co(0)*x11 -  &
                co(0)*x17 + x20) + x18*(-P1(1)*pl(1) + pl(1)*x15 + pl(3)*x2) + &
                x19*(P1(1)*w2(0) - w2(0)*x15 + w2(1)*x2))
    else
      x0 = 2*P2(3)
      x1 = P1(0) + 2*P2(0)
      x2 = -P1(3) - x0 + x1
      x3 = co(0)*w2(2)
      x4 = 2*P2(1)
      x5 = 2*P2(2)
      x6 = P1(1) + P1(2)*cima + cima*x5 + x4
      x7 = co(0)*w2(3)
      x8 = P1(3) + x0 + x1
      x9 = P1(1) - cima*(P1(2) + cima*x4 + x5)
      x10 = co(1)*w2(0)
      x11 = co(1)*w2(1)
      wout(0) = w1(0)*(co(2)*w2(0) + x2*x3 - x6*x7)
      wout(1) = w1(0)*(co(2)*w2(1) - x3*x9 + x7*x8)
      wout(2) = w1(0)*(co(3)*w2(2) + x10*x8 + x11*x6)
      wout(3) = w1(0)*(co(3)*w2(3) + x10*x9 + x11*x2)
    end if 
      end select 
    end subroutine treeSFaF
end module tcSFaF
