!******************************************************************************!
!                                                                              !
!    tcSSFFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSSFFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFFa0)
!       c0*(GammaP(-1,4,3)*P(-1,1) + GammaP(-1,4,3)*P(-1,2) + GammaP(-1,4,3)*P(-1
!       ,3)/2)
!       c1*(GammaM(-1,4,3)*P(-1,1) + GammaM(-1,4,3)*P(-1,2) + GammaM(-1,4,3)*P(-1
!       ,3)/2)
!       ProjP(4,3)*c2
!       ProjM(4,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = P3(2)*cima
      x1 = 2*P1(2)
      x2 = cima*x1
      x3 = 2*P2(2)
      x4 = cima*x3
      x5 = 2*P1(1)
      x6 = 2*P2(1)
      x7 = P3(1) + x5 + x6
      x8 = -x0 - x2 - x4 + x7
      x9 = 2*P1(3)
      x10 = 2*P2(3)
      x11 = 2*P1(0) + 2*P2(0) + P3(0)
      x12 = P3(3) + x10 + x11 + x9
      x13 = co(0)*w3(1)
      x14 = -P3(3) - x10 + x11 - x9
      x15 = pl(0)*x14
      x16 = x0 + x2 + x4 + x7
      x17 = pl(3)*x16
      x18 = co(0)*w3(0)
      x19 = 2*co(3)
      x20 = 2*co(2)*m
      x21 = co(1)*m
      x22 = co(1)*w3(3)
      x23 = w1(0)*w2(0)/2
      x24 = pl(1)*x12
      x25 = pl(2)*x8
      x26 = m*x19
      x27 = 2*co(2)
      x28 = co(0)*m
      wout(0) = x23*(m*x22*x8 - pl(0)*w3(2)*x19 - pl(3)*w3(3)*x19 + w3(0)*x20  &
                 + w3(2)*x12*x21 + x13*(pl(0)*x8 - pl(3)*x12) - x18*(x15 - x17 &
                ))
      wout(1) = x23*(w3(1)*x20 - x13*(x24 - x25) + x18*(pl(1)*x16 - pl(2)*x14  &
                ) - x19*(pl(1)*w3(3) + pl(2)*w3(2)) + x21*(w3(2)*x16 + w3(3)*  &
                x14))
      wout(2) = x23*(w3(2)*(co(1)*x17 - co(1)*x24 + x26) + x22*(cima*pl(1)*(P3(&
                1)*cima + P3(2) + cima*x6 + x1 + x3) - pl(1)*x5 + pl(3)*x14) - &
                x27*(pl(1)*w3(0) - pl(3)*w3(1)) + x28*(w3(0)*x14 - w3(1)*x8))
      wout(3) = -x23*(co(1)*w3(2)*(pl(0)*x16 - pl(2)*x12) - w3(3)*(-co(1)*x15  &
                 + co(1)*x25 + x26) + x27*(pl(0)*w3(1) - pl(2)*w3(0)) + x28*(w3&
                (0)*x16 - w3(1)*x12))
    else
      x0 = 2*co(2)
      x1 = 2*P1(3)
      x2 = 2*P2(3)
      x3 = 2*P1(0) + 2*P2(0) + P3(0)
      x4 = P3(3) + x1 + x2 + x3
      x5 = co(1)*w3(2)
      x6 = P3(2)*cima
      x7 = 2*cima
      x8 = P1(2)*x7
      x9 = P2(2)*x7
      x10 = 2*P1(1) + 2*P2(1) + P3(1)
      x11 = x10 - x6 - x8 - x9
      x12 = co(1)*w3(3)
      x13 = w1(0)*w2(0)/2
      x14 = x10 + x6 + x8 + x9
      x15 = -P3(3) - x1 - x2 + x3
      x16 = 2*co(3)
      x17 = co(0)*w3(0)
      x18 = co(0)*w3(1)
      wout(0) = x13*(w3(0)*x0 + x11*x12 + x4*x5)
      wout(1) = x13*(w3(1)*x0 + x12*x15 + x14*x5)
      wout(2) = x13*(w3(2)*x16 - x11*x18 + x15*x17)
      wout(3) = x13*(w3(3)*x16 - x14*x17 + x18*x4)
    end if 
      end select 
    end subroutine treeSSFFa
end module tcSSFFa
