!******************************************************************************!
!                                                                              !
!    tcSSFaF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFaF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFaF0)
!       c0*(GammaP(-1,3,4)*P(-1,1) + GammaP(-1,3,4)*P(-1,2) + GammaP(-1,3,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,3,4)*P(-1,1) + GammaM(-1,3,4)*P(-1,2) + GammaM(-1,3,4)*P(-1
!       ,4)/2)
!       ProjP(3,4)*c2
!       ProjM(3,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = P1(0) + P2(0) - P3(0)
      x1 = P1(3) + P2(3) - P3(3) + x0
      x2 = pl(1)*x1
      x3 = P3(2)*cima
      x4 = P1(2)*cima
      x5 = P2(2)*cima
      x6 = P1(1) + P2(1) - P3(1)
      x7 = x3 - x4 - x5 + x6
      x8 = pl(2)*x7
      x9 = co(1)*w3(0)
      x10 = -x3 + x4 + x5 + x6
      x11 = -P1(3) - P2(3) + P3(3) + x0
      x12 = co(1)*w3(1)
      x13 = 2*co(3)*w3(3)
      x14 = 2*co(2)*m
      x15 = 2*co(3)*w3(2)
      x16 = co(0)*m*w3(2)
      x17 = co(0)*m*w3(3)
      x18 = w1(0)*w2(0)/2
      x19 = pl(0)*x11
      x20 = pl(3)*x10
      x21 = 2*co(3)*m
      x22 = 2*co(2)
      x23 = co(1)*m
      wout(0) = x18*(pl(1)*x15 - pl(2)*x13 + w3(0)*x14 - x10*x17 + x11*x16 +   &
                x12*(pl(1)*x10 - pl(2)*x11) + x9*(x2 - x8))
      wout(1) = x18*(pl(0)*x13 - pl(3)*x15 + w3(1)*x14 + x1*x17 + x12*(x19 -   &
                x20) - x16*x7 + x9*(pl(0)*x7 - pl(3)*x1))
      wout(2) = x18*(-co(0)*w3(3)*(pl(0)*x10 - pl(2)*x1) + w3(2)*(co(0)*x19 -  &
                co(0)*x8 + x21) + x22*(pl(0)*w3(0) + pl(2)*w3(1)) + x23*(w3(0)*&
                x1 + w3(1)*x10))
      wout(3) = x18*(-co(0)*w3(2)*(pl(1)*x7 - pl(3)*x11) + w3(3)*(co(0)*x2 - co&
                (0)*x20 + x21) + x22*(pl(1)*w3(1) + pl(3)*w3(0)) + x23*(w3(0)* &
                x7 + w3(1)*x11))
    else
      x0 = 2*co(2)
      x1 = P1(0) + P2(0) - P3(0)
      x2 = -P1(3) - P2(3) + P3(3) + x1
      x3 = co(0)*w3(2)
      x4 = P1(2)*cima
      x5 = P2(2)*cima
      x6 = P3(2)*cima
      x7 = P1(1) + P2(1) - P3(1)
      x8 = x4 + x5 - x6 + x7
      x9 = co(0)*w3(3)
      x10 = w1(0)*w2(0)/2
      x11 = P1(3) + P2(3) - P3(3) + x1
      x12 = -x4 - x5 + x6 + x7
      x13 = 2*co(3)
      x14 = co(1)*w3(0)
      x15 = co(1)*w3(1)
      wout(0) = x10*(w3(0)*x0 + x2*x3 - x8*x9)
      wout(1) = x10*(w3(1)*x0 + x11*x9 - x12*x3)
      wout(2) = x10*(w3(2)*x13 + x11*x14 + x15*x8)
      wout(3) = x10*(w3(3)*x13 + x12*x14 + x15*x2)
    end if 
      end select 
    end subroutine treeSSFaF
end module tcSSFaF
