!******************************************************************************!
!                                                                              !
!    tcSVSV.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVSV.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSVSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m, &
    wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVSV0)
!       P(2,4)*P(4,2)*c0
!       Metric(2,4)*P(-1,2)*P(-1,4)*c1
        if (last) VB_last = .true.
        x0 = P1(1) + P3(1)
        x1 = P1(2) + P3(2)
        x2 = P1(3) + P3(3)
        x3 = P1(0) + P3(0)
        x0vec = co(1)*w2(:)
        wout = -w1(0)*w3(0)*(-P2(0)**2*x0vec + P2(:)*co(0)*(-w2(0)*(P2(0) + x3 &
               ) + w2(1)*(P2(1) + x0) + w2(2)*(P2(2) + x1) + w2(3)*(P2(3) + x2 &
               )) + x0vec*(P2(1)**2 + P2(2)**2 + P2(3)**2) + x0vec*(-P2(0)*x3  &
                + P2(1)*x0 + P2(2)*x1 + P2(3)*x2))
      case(SVSV1)
!       P(2,4)*P(4,2)*c0
!       c1*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,2)*P(4,4)*c2
!       Metric(2,4)*P(-1,2)*P(-1,4)*c3
!       c4*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
        if (last) VB_last = .true.
        x0 = P2(0) + P3(0)
        x1 = P1(1) + P2(1)
        x2 = P1(2) + P3(2)
        x3 = P1(3) + P3(3)
        x4 = w2(3)*(P2(3) + x3)
        x5 = w2(1)*(P3(1) + x1) + w2(2)*(P2(2) + x2) + x4
        x0vec = P2(:)*w2(1)
        x1vec = P3(:)*w2(1)
        x6 = P1(2)*w2(2)
        x7 = P2(1)*w2(1)
        x8 = P2(2)*w2(2)
        x9 = P3(2)*w2(2)
        x2vec = P1(:) + P2(:) + P3(:)
        x10 = P2(0)*w2(0)
        x11 = P3(0)*w2(0)
        x3vec = 2*P2(:)
        x12 = P2(1)**2
        x13 = P2(2)**2
        x14 = P2(3)**2
        x15 = P2(0)**2
        x16 = P1(0) + P3(0)
        wout = w1(0)*w3(0)*(-P2(:)*co(0)*(-w2(0)*(P2(0) + x16) + x5) + co(1)*(-&
               P1(0)*w2(0)*x2vec + P1(1)*x0vec + P1(1)*x1vec + P1(:)*(-w2(0)*x0&
                + x5) + P2(:)*w2(3)*(2*P2(3) + x3) - P2(:)*x11 + P2(:)*x6 + P2 &
               (:)*x9 + P3(1)*x0vec + P3(1)*x1vec - P3(:)*x10 - P3(:)*x11 + P3 &
               (:)*x4 + P3(:)*x6 + P3(:)*x7 + P3(:)*x8 + P3(:)*x9 - x10*x3vec  &
                + x3vec*x7 + x3vec*x8) - co(2)*x2vec*(P2(3)*w2(3) - x10 + x7 + &
               x8) - w2(:)*(co(3)*(x12 + x13 + x14 - x15) - co(4)*(-P1(0)**2 + &
               P1(1)**2 + P1(2)**2 + P1(3)**2 - P3(0)**2 + P3(1)**2 + P3(2)**2 &
                + P3(3)**2 + 2*x12 + 2*x13 + 2*x14 - 2*x15)) - w2(:)*(co(3)*(- &
               P2(0)*x16 + P2(1)*(P1(1) + P3(1)) + P2(2)*x2 + P2(3)*x3) - 2*co(&
               4)*(-P1(0)*x0 + P1(1)*P2(1) + P1(2)*P2(2) + P1(3)*P2(3) - P2(0)*&
               P3(0) + P3(1)*x1 + P3(2)*(P1(2) + P2(2)) + P3(3)*(P1(3) + P2(3  &
               )))))
      end select 
    end subroutine treeSVSV
end module tcSVSV
