!******************************************************************************!
!                                                                              !
!    tcSVVS.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVS.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m, &
    wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVS0)
!       P(2,3)*P(3,2)*c0
!       Metric(2,3)*P(-1,2)*P(-1,3)*c1
        wout(0) = w1(0)*(co(0)*(-P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3&
                  )*w3(3))*(-P3(0)*w2(0) + P3(1)*w2(1) + P3(2)*w2(2) + P3(3)*w2&
                  (3)) + co(1)*(-P2(0)*P3(0) + P2(1)*P3(1) + P2(2)*P3(2) + P2(3&
                  )*P3(3))*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3&
                  (3)))
        wout(1:3) = cnul
      case(SVVS1)
!       P(2,3)*P(3,2)*c0
!       P(2,2)*P(3,3)*c1
!       c2*(P(2,2)*P(3,2) + P(2,3)*P(3,3))
!       Metric(2,3)*P(-1,2)*P(-1,3)*c3
!       c4*(Metric(2,3)*P(-1,2)**2 + Metric(2,3)*P(-1,3)**2)
        x0 = P2(3)**2 + P3(3)**2
        x1 = P2(1)*w2(1)
        x2 = P2(2)*w2(2)
        x3 = P3(1)*w2(1)
        x4 = P3(2)*w2(2)
        x5 = P2(1)*w3(1)
        x6 = w3(0)*x1
        x7 = P2(2)*w3(2)
        x8 = w3(0)*x2
        x9 = P2(3)*w3(3)
        x10 = P2(3)*w2(3)
        x11 = w3(0)*x10
        x12 = P3(1)*w3(1)
        x13 = w2(0)*x12
        x14 = P3(2)*w3(2)
        x15 = w2(0)*x14
        x16 = P3(3)*w3(3)
        x17 = w2(0)*x16
        x18 = P3(3)*w2(3)
        x19 = P2(0)**2
        x20 = w2(0)*w3(0)
        x21 = P3(0)**2
        x22 = P2(1)**2
        x23 = w2(1)*w3(1)
        x24 = P3(1)**2
        x25 = P2(2)**2
        x26 = w2(2)*w3(2)
        x27 = P3(2)**2
        x28 = w2(3)*w3(3)
        x29 = P2(0)*P3(0)*w2(0)*w3(0)
        x30 = P2(1)*P3(1)*w2(1)*w3(1)
        x31 = P2(1)*P3(1)*co(3)
        x32 = P3(2)*co(1)*w3(2)
        x33 = P2(2)*co(1)*w2(2)
        x34 = P2(2)*P3(2)*w2(2)*w3(2)
        x35 = co(3)*w2(1)*w3(1)
        x36 = P2(2)*P3(2)*co(3)
        x37 = P2(3)*P3(3)
        x38 = P2(3)*P3(3)*co(3)
        x39 = P2(0)*P3(0)*co(3)
        x40 = P2(0)*co(1)
        x41 = P3(0)*co(1)
        wout(0) = w1(0)*(-P2(0)*P3(0)*x35 + P2(2)*P3(2)*x35 + P3(1)*co(1)*w3(1 &
                  )*x10 + P3(3)*co(1)*w3(3)*x1 + co(0)*(-P2(0)*w3(0) + x5 + x7 &
                   + x9)*(-P3(0)*w2(0) + x18 + x3 + x4) + co(1)*w2(3)*w3(3)*x37&
                   + co(1)*x29 + co(1)*x30 + co(1)*x34 + co(2)*(-P2(0)*(w2(0)* &
                  x5 + w2(0)*x7 + w2(0)*x9 + x11 + x6 + x8) - P3(0)*(w3(0)*x18 &
                   + w3(0)*x3 + w3(0)*x4 + x13 + x15 + x17) + w3(3)*(P2(3)*x1  &
                   + P2(3)*x2 + P3(3)*x3 + P3(3)*x4 + w2(3)*x0) + x1*x7 + x10* &
                  x5 + x10*x7 + x12*x18 + x12*x4 + x14*x18 + x14*x3 + x19*x20  &
                   + x2*x5 + x20*x21 + x22*x23 + x23*x24 + x25*x26 + x26*x27   &
                  ) + co(3)*x29 + co(3)*x30 + co(3)*x34 + co(4)*(-x20 + x23 +  &
                  x26 + x28)*(x0 - x19 - x21 + x22 + x24 + x25 + x27) + x1*x32 &
                   + x10*x32 - x11*x41 + x12*x33 - x13*x40 - x15*x40 + x16*x33 &
                   - x17*x40 - x20*x31 - x20*x36 - x20*x38 + x26*x31 + x26*x38 &
                   - x26*x39 + x28*x31 + x28*x36 + x28*x38 - x28*x39 + x35*x37 &
                   - x41*x6 - x41*x8)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVVS
end module tcSVVS
