!******************************************************************************!
!                                                                              !
!    tcSVVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSVVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVVS0)
!       c0*(Metric(2,3)*P(4,2) - Metric(2,3)*P(4,3) - Metric(2,4)*P(3,2) + Metric
!       (2,4)*P(3,4) + Metric(3,4)*P(2,3) - Metric(3,4)*P(2,4))
        x0 = w2(1)*w3(1)
        x1 = w2(2)*w3(2)
        x2 = w2(0)*w3(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P2(0)*w3(0)
        x6 = P4(1)*w3(1)
        x7 = P4(2)*w3(2)
        x8 = P2(1)*w3(1)
        x9 = P2(2)*w3(2)
        x10 = P4(0)*w3(0)
        x11 = P3(0)*w2(0)
        x12 = P4(1)*w2(1)
        x13 = P4(2)*w2(2)
        x14 = P3(1)*w2(1)
        x15 = P3(2)*w2(2)
        x16 = P4(0)*w2(0)
        x17 = w2(3)*w3(3)
        x18 = P2(0)*w4(0)
        x19 = P2(1)*w4(1)
        x20 = w2(2)*w4(2)
        x21 = w2(0)*w3(0)*w4(2)
        x22 = w2(1)*w4(1)
        x23 = P2(3)*w3(3)
        x24 = w3(1)*w4(1)
        x25 = w3(2)*w4(2)
        x26 = w3(0)*w4(0)
        x27 = w2(1)*w3(1)*w4(2)
        x28 = w2(3)*w3(3)*w4(2)
        x29 = P3(3)*w2(3)
        x30 = w2(0)*w4(0)
        x31 = P4(3)*w3(3)
        x32 = P4(3)*w2(3)
        x33 = P3(0)*w4(0)
        wout(0) = co(0)*w1(0)*(P2(2)*x21 - P2(2)*x27 - P2(2)*x28 + P3(1)*w4(1  &
                  )*(x17 + x3) - P3(2)*x21 + P3(2)*x27 + P3(2)*x28 - w4(3)*(P2(&
                  3)*x4 - P3(3)*x4 + w2(3)*(-x10 + x5 + x6 + x7 - x8 - x9) - w3&
                  (3)*(x11 + x12 + x13 - x14 - x15 - x16)) + x0*x18 - x0*x33 + &
                  x1*x18 - x1*x19 - x1*x33 + x10*x20 + x10*x22 + x11*x24 + x11*&
                  x25 + x12*x25 - x12*x26 + x13*x24 - x13*x26 - x14*x25 + x14* &
                  x26 - x15*x24 + x15*x26 - x16*x24 - x16*x25 + x17*x18 - x17* &
                  x19 - x17*x33 + x19*x2 + x20*x23 - x20*x31 - x20*x5 - x20*x6 &
                   + x20*x8 + x22*x23 - x22*x31 - x22*x5 - x22*x7 + x22*x9 -   &
                  x23*x30 - x24*x29 + x24*x32 - x25*x29 + x25*x32 + x26*x29 -  &
                  x26*x32 + x30*x31 + x30*x6 + x30*x7 - x30*x8 - x30*x9)
        wout(1:3) = cnul
      case(SVVVS1)
!       Metric(2,4)*P(3,4)*c0
!       Metric(3,4)*P(2,4)*c1
!       Metric(2,3)*P(4,2)*c2
!       Metric(2,4)*P(3,2)*c3
!       Metric(2,3)*P(4,3)*c4
!       Metric(3,4)*P(2,3)*c5
        x0 = w2(1)*w3(1)
        x1 = w2(2)*w3(2)
        x2 = w2(3)*w3(3)
        x3 = w2(0)*w3(0)
        x4 = w2(1)*w4(1)
        x5 = w2(2)*w4(2)
        x6 = w2(3)*w4(3)
        x7 = w2(0)*w4(0)
        x8 = w2(0)*w3(0)*w4(0)
        x9 = w2(1)*w3(1)*w4(1)
        x10 = P3(1)*co(4)*w4(1)
        x11 = P3(1)*co(5)
        x12 = w2(1)*w3(2)*w4(2)
        x13 = w2(1)*w3(3)*w4(3)
        x14 = P3(2)*co(4)*w4(2)
        x15 = w2(2)*w3(2)*w4(2)
        x16 = P3(2)*co(5)
        x17 = w2(2)*w3(1)*w4(1)
        x18 = w2(2)*w3(3)*w4(3)
        x19 = P3(3)*co(4)*w4(3)
        x20 = P3(3)*co(5)*w2(3)
        x21 = w3(1)*w4(1)
        x22 = w3(2)*w4(2)
        x23 = P4(1)*co(0)*w3(1)
        x24 = P4(1)*co(1)
        x25 = P4(2)*co(0)*w3(2)
        x26 = P4(2)*co(1)
        x27 = P4(3)*co(0)*w3(3)
        x28 = P4(3)*w2(3)*w3(3)*w4(3)
        x29 = P4(3)*co(1)*w2(3)
        x30 = P3(0)*co(4)*w4(0)
        x31 = P3(0)*co(5)*w2(0)
        x32 = w3(3)*w4(3)
        x33 = w2(1)*w3(0)*w4(0)
        x34 = w2(2)*w3(0)*w4(0)
        x35 = w3(0)*w4(0)
        x36 = P4(0)*co(0)*w3(0)
        x37 = P4(0)*co(1)*w2(0)
        wout(0) = -w1(0)*(P3(0)*co(4)*x8 + P3(0)*co(5)*x8 + P3(1)*co(4)*x9 + P3&
                  (2)*co(4)*x15 + P3(3)*co(5)*w2(3)*w3(3)*w4(3) + P4(0)*co(0)* &
                  x8 + P4(0)*co(1)*x8 + P4(1)*co(0)*x9 + co(0)*x28 + co(1)*x28 &
                   + co(2)*(x0 + x1 + x2 - x3)*(-P2(0)*w4(0) + P2(1)*w4(1) + P2&
                  (2)*w4(2) + P2(3)*w4(3)) + co(3)*(x4 + x5 + x6 - x7)*(-P2(0)*&
                  w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)) + x0*x14 +  &
                  x0*x19 - x0*x30 + x1*x10 + x1*x19 - x1*x30 + x10*x2 - x10*x3 &
                   + x11*x12 + x11*x13 - x11*x33 + x11*x9 + x12*x24 + x13*x24  &
                   + x14*x2 - x14*x3 + x15*x16 + x15*x26 + x16*x17 + x16*x18 - &
                  x16*x34 + x17*x26 + x18*x26 + x19*x2 - x19*x3 - x2*x30 + x20*&
                  x21 + x20*x22 - x20*x35 + x21*x29 - x21*x31 - x21*x37 + x22* &
                  x29 - x22*x31 - x22*x37 + x23*x5 + x23*x6 - x23*x7 - x24*x33 &
                   + x24*x9 + x25*x4 + x25*x5 + x25*x6 - x25*x7 - x26*x34 + x27&
                  *x4 + x27*x5 - x27*x7 - x29*x35 - x31*x32 - x32*x37 - x36*x4 &
                   - x36*x5 - x36*x6)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVVVS
end module tcSVVVS
