!******************************************************************************!
!                                                                              !
!    tcSVVVSS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVVSS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeSVVVSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
      complex(kind=dp), intent(in), dimension(0:3) :: w5
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVVSS0)
!       c0*(Metric(2,3)*P(4,2) - Metric(2,3)*P(4,3) - Metric(2,4)*P(3,2) + Metric
!       (2,4)*P(3,4) + Metric(3,4)*P(2,3) - Metric(3,4)*P(2,4))
        x0 = w2(1)*w3(1)
        x1 = w2(2)*w3(2)
        x2 = w2(0)*w3(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P2(0)*w3(0)
        x6 = P4(1)*w3(1)
        x7 = P4(2)*w3(2)
        x8 = P2(1)*w3(1)
        x9 = P2(2)*w3(2)
        x10 = P4(0)*w3(0)
        x11 = P3(0)*w2(0)
        x12 = P4(1)*w2(1)
        x13 = P4(2)*w2(2)
        x14 = P3(1)*w2(1)
        x15 = P3(2)*w2(2)
        x16 = P4(0)*w2(0)
        x17 = w2(3)*w3(3)
        x18 = P2(0)*w4(0)
        x19 = P2(1)*w4(1)
        x20 = w2(2)*w4(2)
        x21 = w2(0)*w3(0)*w4(2)
        x22 = w2(1)*w4(1)
        x23 = P2(3)*w3(3)
        x24 = w3(1)*w4(1)
        x25 = w3(2)*w4(2)
        x26 = w3(0)*w4(0)
        x27 = w2(1)*w3(1)*w4(2)
        x28 = w2(3)*w3(3)*w4(2)
        x29 = P3(3)*w2(3)
        x30 = w2(0)*w4(0)
        x31 = P4(3)*w3(3)
        x32 = P4(3)*w2(3)
        x33 = P3(0)*w4(0)
        wout(0) = co(0)*w1(0)*w5(0)*(P2(2)*x21 - P2(2)*x27 - P2(2)*x28 + P3(1)*&
                  w4(1)*(x17 + x3) - P3(2)*x21 + P3(2)*x27 + P3(2)*x28 - w4(3  &
                  )*(P2(3)*x4 - P3(3)*x4 + w2(3)*(-x10 + x5 + x6 + x7 - x8 - x9&
                  ) - w3(3)*(x11 + x12 + x13 - x14 - x15 - x16)) + x0*x18 - x0*&
                  x33 + x1*x18 - x1*x19 - x1*x33 + x10*x20 + x10*x22 + x11*x24 &
                   + x11*x25 + x12*x25 - x12*x26 + x13*x24 - x13*x26 - x14*x25 &
                   + x14*x26 - x15*x24 + x15*x26 - x16*x24 - x16*x25 + x17*x18 &
                   - x17*x19 - x17*x33 + x19*x2 + x20*x23 - x20*x31 - x20*x5 - &
                  x20*x6 + x20*x8 + x22*x23 - x22*x31 - x22*x5 - x22*x7 + x22* &
                  x9 - x23*x30 - x24*x29 + x24*x32 - x25*x29 + x25*x32 + x26*  &
                  x29 - x26*x32 + x30*x31 + x30*x6 + x30*x7 - x30*x8 - x30*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVVVSS
end module tcSVVVSS
