!******************************************************************************!
!                                                                              !
!    tcVSSVVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSVVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeVSSVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
      complex(kind=dp), intent(in), dimension(0:3) :: w5
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSVVS0)
!       c0*(Metric(1,4)*P(5,1) - Metric(1,4)*P(5,4) - Metric(1,5)*P(4,1) + Metric
!       (1,5)*P(4,5) + Metric(4,5)*P(1,4) - Metric(4,5)*P(1,5))
        x0 = w1(1)*w4(1)
        x1 = w1(2)*w4(2)
        x2 = w1(0)*w4(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P1(0)*w4(0)
        x6 = P5(1)*w4(1)
        x7 = P5(2)*w4(2)
        x8 = P1(1)*w4(1)
        x9 = P1(2)*w4(2)
        x10 = P5(0)*w4(0)
        x11 = P4(0)*w1(0)
        x12 = P5(1)*w1(1)
        x13 = P5(2)*w1(2)
        x14 = P4(1)*w1(1)
        x15 = P4(2)*w1(2)
        x16 = P5(0)*w1(0)
        x17 = w1(3)*w4(3)
        x18 = w1(1)*w4(1)*w5(0)
        x19 = w1(2)*w4(2)*w5(0)
        x20 = w1(3)*w4(3)*w5(0)
        x21 = P1(1)*w5(1)
        x22 = w1(2)*w5(2)
        x23 = P1(2)*w5(2)
        x24 = w1(1)*w5(1)
        x25 = P1(3)*w4(3)
        x26 = w4(1)*w5(1)
        x27 = w4(2)*w5(2)
        x28 = w4(0)*w5(0)
        x29 = P4(2)*w5(2)
        x30 = P4(3)*w1(3)
        x31 = w1(0)*w5(0)
        x32 = P5(3)*w4(3)
        x33 = P5(3)*w1(3)
        wout(0) = co(0)*w2(0)*w3(0)*(P1(0)*x18 + P1(0)*x19 + P1(0)*x20 - P4(0)*&
                  x18 - P4(0)*x19 - P4(0)*x20 + P4(1)*w5(1)*(x17 + x3) - w5(3  &
                  )*(P1(3)*x4 - P4(3)*x4 + w1(3)*(-x10 + x5 + x6 + x7 - x8 - x9&
                  ) - w4(3)*(x11 + x12 + x13 - x14 - x15 - x16)) - x0*x23 + x0*&
                  x29 - x1*x21 + x10*x22 + x10*x24 + x11*x26 + x11*x27 + x12*  &
                  x27 - x12*x28 + x13*x26 - x13*x28 - x14*x27 + x14*x28 - x15* &
                  x26 + x15*x28 - x16*x26 - x16*x27 - x17*x21 - x17*x23 + x17* &
                  x29 + x2*x21 + x2*x23 - x2*x29 + x22*x25 - x22*x32 - x22*x5  &
                   - x22*x6 + x22*x8 + x24*x25 - x24*x32 - x24*x5 - x24*x7 +   &
                  x24*x9 - x25*x31 - x26*x30 + x26*x33 - x27*x30 + x27*x33 +   &
                  x28*x30 - x28*x33 + x31*x32 + x31*x6 + x31*x7 - x31*x8 - x31*&
                  x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeVSSVVS
end module tcVSSVVS
