!******************************************************************************!
!                                                                              !
!    tcVVS.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVS.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeVVS(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVS0)
!       P(1,2)*P(2,1)*c0
!       Metric(1,2)*P(-1,1)*P(-1,2)*c1
        wout(0) = co(0)*(-P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3 &
                  ))*(-P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3    &
                  )) + co(1)*(-P1(0)*P2(0) + P1(1)*P2(1) + P1(2)*P2(2) + P1(3)*&
                  P2(3))*(-w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3&
                  ))
        wout(1:3) = cnul
      case(VVS1)
!       c0*(P(1,2)*P(2,3) + P(1,3)*P(2,1))
!       P(1,2)*P(2,1)*c1
!       P(1,3)*P(2,3)*c2
!       Metric(1,2)*P(-1,3)**2*c3
!       c4*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,1)*P(-1,3))
        x0 = P2(1)*w1(1)
        x1 = P2(2)*w1(2)
        x2 = P2(3)*w1(3)
        x3 = P2(0)*w1(0)
        x4 = 2*co(3)
        x5 = P1(1)*P2(1)
        x6 = P1(2)*P2(2)
        x7 = P1(3)*P2(3)
        x8 = P1(0)*P2(0)
        x9 = P1(3) + P2(3)
        x10 = P1(1)*P1(3)
        x11 = P1(2)*w1(2)
        x12 = 2*P1(3)
        x13 = w1(0)*w2(1)
        x14 = w1(1)*w2(0)
        x15 = w1(0)*w2(2)
        x16 = P1(2)*x15
        x17 = w1(0)*w2(3)
        x18 = P1(3)*w1(3)
        x19 = w1(0)*w2(0)
        x20 = P2(1)*x14
        x21 = w2(0)*x1
        x22 = w2(0)*x2
        x23 = P1(0)**2
        x24 = P2(0)**2
        x25 = P1(1)**2
        x26 = w1(1)*w2(1)
        x27 = P2(1)**2
        x28 = P1(2)**2
        x29 = w1(2)*w2(2)
        x30 = P2(2)**2
        x31 = P1(2)*w2(2)
        x32 = P2(2)*w2(2)
        x33 = P2(1)*w2(1)
        x34 = P1(1)*P2(1)*w1(1)*w2(1)
        x35 = 2*P1(1)*w2(1)
        x36 = 2*P1(2)*w2(2)
        x37 = P1(2)*P2(2)*w1(2)*w2(2)
        x38 = P1(1) + P2(1)
        x39 = P1(2) + P2(2)
        x40 = P1(0) + P2(0)
        x41 = P1(0)*P2(0)*w1(0)*w2(0)
        x42 = co(4)*w1(1)*w2(1)
        x43 = co(4)*w1(2)*w2(2)
        x44 = co(4)*w1(0)*w2(0)
        x45 = P1(1)*co(1)*w2(1)
        x46 = P1(2)*co(1)*w2(2)
        x47 = P1(0)*co(1)
        x48 = 2*co(3)*w1(1)*w2(1)
        x49 = 2*co(3)*w1(2)*w2(2)
        x50 = 2*co(3)*w1(0)*w2(0)
        x51 = 2*P1(3)*P2(3)*co(3)
        wout(0) = -co(0)*(-P1(0)*(P1(1)*(x13 + x14) + P1(3)*x17 - 2*P2(0)*x19  &
                   + w2(0)*x11 + w2(0)*x18 + x16 + 2*x20 + 2*x21 + 2*x22) + P1(&
                  1)*w1(1)*x31 + P1(1)*w2(1)*x11 - P2(0)*(2*P1(1)*x13 + P2(1)* &
                  x13 + P2(2)*x15 + 2*x16 + x17*(P2(3) + x12) + x20 + x21 + x22&
                  ) + w1(3)*w2(1)*x10 + w2(3)*(P1(3)*x11 + P2(3)*x0 + P2(3)*x1 &
                   + w1(1)*x10 + w1(3)*x9**2 + x0*x12 + x1*x12) + x0*x32 + x0* &
                  x36 + x1*x33 + x1*x35 + x18*x31 + x19*x23 + x19*x24 + x2*x32 &
                   + x2*x33 + x2*x35 + x2*x36 + x25*x26 + x26*x27 + x28*x29 +  &
                  x29*x30 + 2*x34 + 2*x37) + co(1)*x34 + co(1)*x37 + co(1)*x41 &
                   + co(2)*(-w1(0)*x40 + w1(1)*x38 + w1(2)*x39 + w1(3)*x9)*(-w2&
                  (0)*x40 + w2(1)*x38 + w2(2)*x39 + w2(3)*x9) + co(3)*(w1(3)*w2&
                  (3) - x19 + x26 + x29)*(P1(3)**2 + P2(3)**2 - x23 - x24 + x25&
                   + x27 + x28 + x30) + w2(3)*(P1(3)*co(1)*(x0 + x1 + x2 - x3  &
                  ) + w1(3)*(-co(4) + x4)*(x5 + x6 + x7 - x8)) + x0*x46 + x1*  &
                  x45 - x19*x51 + x2*x45 + x2*x46 - x20*x47 - x21*x47 - x22*x47&
                   + x26*x51 + x29*x51 - x3*x45 - x3*x46 + x34*x4 + x37*x4 + x4&
                  *x41 - x42*x5 - x42*x6 - x42*x7 + x42*x8 - x43*x5 - x43*x6 - &
                  x43*x7 + x43*x8 + x44*x5 + x44*x6 + x44*x7 - x44*x8 + x48*x6 &
                   - x48*x8 + x49*x5 - x49*x8 - x5*x50 - x50*x6
        wout(1:3) = cnul
      end select 
    end subroutine treeVVS
end module tcVVS
