!******************************************************************************!
!                                                                              !
!    tcVVVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 2015                                 |            !
!        |       | UFO version: 0.1                               |            !
!        |       | Generation date: 2020-08-03 19:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine treeVVVSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVSS0)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (1,3)*P(2,3) + Metric(2,3)*P(1,2) - Metric(2,3)*P(1,3))
        x0 = w1(1)*w2(1)
        x1 = w1(2)*w2(2)
        x2 = w1(0)*w2(0)
        x3 = x1 - x2
        x4 = x0 + x3
        x5 = P1(0)*w2(0)
        x6 = P3(1)*w2(1)
        x7 = P3(2)*w2(2)
        x8 = P1(1)*w2(1)
        x9 = P1(2)*w2(2)
        x10 = P3(0)*w2(0)
        x11 = P2(0)*w1(0)
        x12 = P3(1)*w1(1)
        x13 = P3(2)*w1(2)
        x14 = P2(1)*w1(1)
        x15 = P2(2)*w1(2)
        x16 = P3(0)*w1(0)
        x17 = w1(3)*w2(3)
        x18 = w1(1)*w2(1)*w3(0)
        x19 = w1(2)*w2(2)*w3(0)
        x20 = w1(3)*w2(3)*w3(0)
        x21 = P1(1)*w3(1)
        x22 = w1(2)*w3(2)
        x23 = P1(2)*w3(2)
        x24 = w1(1)*w3(1)
        x25 = P1(3)*w2(3)
        x26 = w1(2)*w2(3)*w3(2)
        x27 = w2(1)*w3(1)
        x28 = w2(2)*w3(2)
        x29 = w2(0)*w3(0)
        x30 = P2(2)*w3(2)
        x31 = P2(3)*w1(3)
        x32 = w1(0)*w3(0)
        x33 = P3(3)*w2(3)
        x34 = P3(3)*w1(3)
        x35 = w1(3)*w2(2)*w3(2)
        wout(0) = co(0)*w4(0)*(P1(0)*x18 + P1(0)*x19 + P1(0)*x20 + P1(3)*x26 - &
                  P2(0)*x18 - P2(0)*x19 - P2(0)*x20 + P2(1)*w3(1)*(x17 + x3) - &
                  P2(3)*x35 - P3(3)*x26 + P3(3)*x35 - w3(3)*(P1(3)*x4 - P2(3)* &
                  x4 + w1(3)*(-x10 + x5 + x6 + x7 - x8 - x9) - w2(3)*(x11 + x12&
                   + x13 - x14 - x15 - x16)) - x0*x23 + x0*x30 - x1*x21 + x10* &
                  x22 + x10*x24 + x11*x27 + x11*x28 + x12*x28 - x12*x29 + x13* &
                  x27 - x13*x29 - x14*x28 + x14*x29 - x15*x27 + x15*x29 - x16* &
                  x27 - x16*x28 - x17*x21 - x17*x23 + x17*x30 + x2*x21 + x2*x23&
                   - x2*x30 - x22*x5 - x22*x6 + x22*x8 + x24*x25 - x24*x33 -   &
                  x24*x5 - x24*x7 + x24*x9 - x25*x32 - x27*x31 + x27*x34 + x29*&
                  x31 - x29*x34 + x32*x33 + x32*x6 + x32*x7 - x32*x8 - x32*x9)
        wout(1:3) = cnul
      case(VVVSS1)
!       Metric(1,2)*P(3,1)*c0
!       Metric(1,3)*P(2,1)*c1
!       Metric(1,2)*P(3,2)*c2
!       Metric(1,3)*P(2,3)*c3
!       Metric(2,3)*P(1,2)*c4
!       Metric(2,3)*P(1,3)*c5
        x0 = w1(1)*w2(1)
        x1 = w1(2)*w2(2)
        x2 = w1(3)*w2(3)
        x3 = w1(0)*w2(0)
        x4 = w1(1)*w3(1)
        x5 = w1(2)*w3(2)
        x6 = w1(3)*w3(3)
        x7 = w1(0)*w3(0)
        x8 = w1(0)*w2(0)*w3(0)
        x9 = P2(0)*co(4)
        x10 = w1(1)*w2(1)*w3(1)
        x11 = P2(1)*co(2)*w3(1)
        x12 = P2(1)*co(4)
        x13 = P2(1)*w1(1)
        x14 = co(4)*w2(2)*w3(2)
        x15 = co(4)*w2(3)*w3(3)
        x16 = P2(2)*co(2)*w3(2)
        x17 = w2(1)*w3(1)
        x18 = P2(2)*co(4)*w1(2)
        x19 = P2(3)*co(2)*w3(3)
        x20 = P2(3)*co(4)*w1(3)
        x21 = P3(1)*co(3)*w2(1)
        x22 = P3(1)*co(5)
        x23 = w2(2)*w3(2)
        x24 = P3(1)*co(5)*w1(1)
        x25 = w2(3)*w3(3)
        x26 = P3(2)*co(3)*w2(2)
        x27 = P3(2)*w1(2)*w2(2)
        x28 = P3(2)*co(5)*w1(2)
        x29 = P3(3)*co(3)*w2(3)
        x30 = P3(3)*w1(3)*w2(3)*w3(3)
        x31 = P3(3)*co(5)*w1(3)
        x32 = P2(0)*co(2)*w3(0)
        x33 = w1(0)*w2(2)
        x34 = w1(1)*w2(0)*w3(0)
        x35 = w2(0)*w3(0)
        x36 = P3(0)*co(3)*w2(0)
        x37 = P3(0)*co(5)*w1(0)
        wout(0) = -w4(0)*(P2(0)*co(2)*x8 - P2(0)*co(4)*w3(2)*x33 - P2(0)*w1(0)*&
                  x15 + P2(1)*co(2)*x10 + P2(2)*co(4)*w3(2)*x1 + P2(2)*w1(2)*  &
                  x15 + P2(3)*co(4)*w1(3)*w2(3)*w3(3) + P2(3)*w1(3)*x14 + P3(0 &
                  )*co(3)*x8 - P3(0)*co(5)*w3(2)*x33 + P3(0)*co(5)*x8 + P3(1)* &
                  co(3)*x10 + co(0)*(x0 + x1 + x2 - x3)*(-P1(0)*w3(0) + P1(1)* &
                  w3(1) + P1(2)*w3(2) + P1(3)*w3(3)) + co(1)*(x4 + x5 + x6 - x7&
                  )*(-P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)) + &
                  co(3)*w3(2)*x27 + co(3)*x30 + co(5)*w3(2)*x27 + co(5)*x30 -  &
                  w1(0)*w2(1)*w3(1)*x9 + x0*x16 + x0*x19 - x0*x32 + x1*x11 + x1&
                  *x16 + x1*x19 - x1*x32 + x10*x12 + x10*x22 + x11*x2 - x11*x3 &
                   - x12*x34 + x13*x14 + x13*x15 + x16*x2 - x16*x3 + x17*x18 + &
                  x17*x20 + x17*x28 + x17*x31 - x17*x37 - x18*x35 + x19*x2 -   &
                  x19*x3 - x2*x32 - x20*x35 + x21*x5 + x21*x6 - x21*x7 - x22*  &
                  x34 + x23*x24 + x23*x31 + x24*x25 + x25*x28 - x25*x37 + x26* &
                  x4 + x26*x6 - x26*x7 - x28*x35 + x29*x4 + x29*x5 - x29*x7 -  &
                  x31*x35 - x36*x4 - x36*x5 - x36*x6 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeVVVSS
end module tcVVVSS
